#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=TCTimer.ico
#AutoIt3Wrapper_Add_Constants=n
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                                                                                       ;;
;;  AutoIt Version: 3.3.0.0                                                              ;;
;;                                                                                       ;;
;;  Template AutoIt script.                                                              ;;
;;                                                                                       ;;
;;  AUTHOR:  TheSaint <thsaint@ihug.com.au>                                              ;;
;;                                                                                       ;;
;;  SCRIPT FUNCTION:  Frontend to set specified delay between TeraCopy Jobs              ;;
;;                                                                                       ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; Script generated by AutoBuilder 0.8 Prototype

; GUI FUNCTIONS
; AdvancedDelayOpts(), DropboxGUI(), ViewCombineList()
; FUNCTIONS
; AddSourceToCombineList(), ClearQuery(), EnableDisableControls($state), GetCombineFileTruePathsCount()
; GetFolderList($srcpth), GetSetProjectFile($val), GetTotalSize(), LoadProject(), RemoveAfterCancel()
; RemoveFinishedJobs(), RemoveQuery(), SaveJobSettings(), SetControlsState($state), ShowDetailsForJob()
; SourceGetBytes(), SourceGetSize($ret), UpdateDestinationValues()

#include <Constants.au3>
#include <GUIConstantsEx.au3>
#include <Misc.au3>
#include <WindowsConstants.au3>
#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <ComboConstants.au3>
#include <ListBoxConstants.au3>
#include <StaticConstants.au3>
#include <UpDownConstants.au3>
#include <File.au3>
#include <Date.au3>
#include <Array.au3>

_Singleton("teracopy-timer-thsaint")

Global $Button_add, $Button_adv, $Button_comb, $Button_del, $Button_dest, $Button_i, $Button_last
Global $Button_min, $Button_sav, $Button_sfld, $Button_sfle, $Button_set, $Button_srce, $Button_start
Global $Button_x, $Checkbox_ask, $Checkbox_shut, $Checkbox_thumb, $Checkbox_up, $Checkbox_use
Global $Combo_fav, $Combo_how, $Combo_job, $Combo_ord, $Combo_wait, $Context_menu
Global $Group_delay, $Group_dest, $Group_fav, $Group_job, $Group_ord, $Group_pths, $Group_srce
Global $Input_delay, $Input_dest, $Input_ord, $Input_srce, $Item_remove
Global $Label_add, $Label_current, $Label_delay, $Label_multi, $Label_size, $Label_sum, $Label_total
Global $Label_wait, $Updown_delay, $Updown_ord

Global $above, $advance, $advanced, $AdvancedDelay, $advice, $ans, $ask, $b, $below, $bytes, $c, $change
Global $copy, $curr, $d, $del, $delay, $dest, $diff, $dll, $double, $dropped, $e, $f, $fav, $favs, $file
Global $fixnum, $fv, $half, $handle, $height, $icoB, $icofle, $icoI, $icoX, $idle, $inifle, $j, $job
Global $jobs, $left, $lines, $loc, $logfle, $mbs, $mins, $minutes, $mode, $n, $new, $newlist, $none
Global $num, $nums, $pause, $pos, $proc, $pth, $remain, $remlist, $remove, $report, $rest, $Scriptname
Global $shell, $shut, $size, $skip, $sline, $source, $srcpth, $state, $stop, $stopfle, $sub, $sub_1
Global $sub_2, $subs, $subtot, $sum, $t, $tasks, $teracopy, $TCTimer, $time, $tmp, $top, $tot, $total
Global $typ, $up, $update, $updwn, $use, $user, $wait, $waiting, $width, $winsize

Global $entries, $entry, $list, $project, $projects, $projfle, $updated, $val

Global $WM_DROPFILES = 0x233, $gaDropFiles[1], $a, $addconc, $addsolo, $array, $as, $combfle, $combine
Global $combsze, $how, $p, $paths, $pths, $res, $ret, $sizes, $srce, $thmbs

$inifle = @ScriptDir & "\Settings.ini"
$logfle = @ScriptDir & "\Report.log"
$projects = @ScriptDir & "\Projects"
$Scriptname = "TeraCopy Timer v3.5"
$stopfle = @ScriptDir & "\Stop.exe"

If Not FileExists($logfle) Then
	$file = FileOpen($logfle, 1)
	FileWriteLine($file, "List of TeraCopy Jobs processed by this program")
	FileWriteLine($file, "===============================================")
	FileWriteLine($file, @CRLF)
	FileClose($file)
EndIf

If Not FileExists($projects) Then DirCreate($projects)

$teracopy = IniRead($inifle, "TeraCopy", "path", "")
If $teracopy = "" Or Not FileExists($teracopy) Then
	$teracopy = "C:\Program Files\SysTools\TeraCopy\TeraCopy.exe"
	If FileExists($teracopy) Then
		IniWrite($inifle, "TeraCopy", "path", $teracopy)
	Else
		$teracopy = "C:\Program Files\TeraCopy\TeraCopy.exe"
		If FileExists($teracopy) Then
			IniWrite($inifle, "TeraCopy", "path", $teracopy)
		Else
			$pth = FileOpenDialog("Choose the TeraCopy executable file", @ProgramFilesDir, "Program file (*.exe)", 3, "TeraCopy.exe")
			If @error <> 1 And $pth <> "" And StringMid($pth, 2, 2) = ":\" Then
				$teracopy = $pth
				IniWrite($inifle, "TeraCopy", "path", $teracopy)
			Else
				$teracopy = ""
			EndIf
		EndIf
	EndIf
EndIf
If $teracopy = "" Then
	MsgBox(262192, "Program Error", _
		"TeraCopy is required to use this program frontend." & @LF & @LF & _
		"Both a Free and Pro version can be found on the" & @LF & _
		"web - www.codesector.com", 0)
	Exit
EndIf

$updated = IniRead($inifle, "TeraCopy Timer", "updated", "")
If $updated = "" Then
	$jobs = IniRead($inifle, "Jobs", "names", "")
	If $jobs = "" Then $jobs = "||"
	If $jobs = "||" Then
		$updated = 1
		IniWrite($inifle, "TeraCopy Timer", "updated", $updated)
	Else
		GetSetProjectFile(0)
		$entry = IniReadSection($inifle, "Jobs")
		If @error = 1 Then
			$updated = "error"
			MsgBox(262192, "Error Report", "Program could not be updated.", 0)
		Else
			$res = IniWriteSection($projfle, "Jobs", $entry)
			If $res <> 1 Then
				$updated = "error"
				MsgBox(262192, "Error Report", "Project file could not be created.", 0)
			EndIf
		EndIf
		If $updated = "" Then
			SplashTextOn("", "Migrating Jobs!", 180, 80, -1, -1, 33)
			$job = StringSplit($jobs, "|")
			If $job[0] > 2 Then
				$list = ""
				For $j = 3 To $job[0]
					$entry = $job[$j]
					If $entry <> "" Then
						$entries = IniReadSection($inifle, $entry)
						If @error = 1 Then
							$updated = "error"
							MsgBox(262192, "Error Report", "A job could not be updated.", 0)
						Else
							$res = IniWriteSection($projfle, $entry, $entries)
							If $res = 1 Then
								If $list = "" Then
									$list = $entry
								Else
									$list = $list & "|" & $entry
								EndIf
							Else
								$updated = "error"
							EndIf
						EndIf
					EndIf
				Next
			Else
				$updated = "error"
				MsgBox(262192, "Error Report", "No jobs found for updating.", 0)
			EndIf
			If $updated = "" Then
				IniDelete($inifle, "Jobs")
				$list = StringSplit($list, "|")
				For $j = 1 To $list[0]
					$entry = $list[$j]
					If $entry <> "" Then IniDelete($inifle, $entry)
				Next
				;
				; NOTE - If updating from a much older version of the program, size may not exist.
				$sum = IniRead($inifle, "Total Size", "sum", "")
				If $sum <> "" Then
					$entry = IniReadSection($inifle, "Total Size")
					If @error = 1 Then
						$updated = "error"
						MsgBox(262192, "Error Report", "Total Size for project not found.", 0)
					Else
						$res = IniWriteSection($projfle, "Total Size", $entry)
						If $res = 1 Then
							IniDelete($inifle, "Total Size")
						Else
							$updated = "error"
						EndIf
					EndIf
				EndIf
				If $updated = "" Then
					$updated = 1
					IniWrite($inifle, "TeraCopy Timer", "updated", $updated)
					IniWrite($inifle, "Last Project", "file", $projfle)
					MsgBox(262208, "Program Advice", _
						"Program has been updated to support" & @LF & _
						"loading or creating separate projects." & @LF & @LF & _
						"Current list of jobs has been migrated" & @LF & _
						"to a project in the Projects folder." & @LF & @LF & _
						"Projects have a date based file name.", 0)
				EndIf
			EndIf
			SplashOff()
		EndIf
	EndIf
EndIf
If $updated = "" Then
	$projfle = $inifle
ElseIf $projfle = "" Then
	$projfle = IniRead($inifle, "Last Project", "file", "")
EndIf

$left = IniRead($inifle, "Window Position", "left", "-1")
$top = IniRead($inifle, "Window Position", "top", "-1")
$TCTimer = GuiCreate($Scriptname, 560, 350, $left, $top, $WS_OVERLAPPED + $WS_CAPTION + $WS_SYSMENU _
				+ $WS_VISIBLE + $WS_CLIPSIBLINGS + $WS_MINIMIZEBOX, $WS_EX_TOPMOST + $WS_EX_ACCEPTFILES)
;
; CONTROLS
$Label_multi = GUICtrlCreateLabel("Multiple File && Folder Support = DISABLED", 10, 3, 195, 18, $SS_CENTER + $SS_CENTERIMAGE + $SS_SUNKEN)
GUICtrlSetFont($Label_multi, 7, 400, 0, "Small Fonts")
GUICtrlSetBkColor($Label_multi, 0xF00000)
GUICtrlSetColor($Label_multi, 0xFFFFFF)
GUICtrlSetResizing($Label_multi, $GUI_DOCKALL)
$Label_add = GUICtrlCreateLabel("INDIVIDUAL", 210, 3, 75, 21, $SS_CENTER + $SS_CENTERIMAGE + $SS_SUNKEN)
GUICtrlSetFont($Label_add, 7, 400, 0, "Small Fonts")
GUICtrlSetBkColor($Label_add, 0xF000F0)
GUICtrlSetColor($Label_add, 0xFFFFFF)
GUICtrlSetResizing($Label_add, $GUI_DOCKALL)
GUICtrlSetState($Label_add, $GUI_HIDE)
$Combo_how = GuiCtrlCreateCombo("", 290, 3, 75, 21)
GUICtrlSetFont($Combo_how, 7, 400, 0, "Small Fonts")
GUICtrlSetTip($Combo_how, "Add to List choice!")
GUICtrlSetResizing($Combo_how, $GUI_DOCKALL)
GUICtrlSetState($Combo_how, $GUI_HIDE)
$Button_comb = GuiCtrlCreateButton("LOAD or NEW", 220, 3, 100, 21)
GUICtrlSetFont($Button_comb, 7, 600, 0, "Small Fonts")
GUICtrlSetTip($Button_comb, "Load or Create a Project!")
GUICtrlSetResizing($Button_comb, $GUI_DOCKALL)
;
$Group_pths = GuiCtrlCreateGroup("Job Paths", 10, 25, 540, 170)
GUICtrlSetResizing($Group_pths, $GUI_DOCKALL)
;;;;;;;
$Button_min = GuiCtrlCreateButton("MIN", 125, 36, 45, 18)
GUICtrlSetFont($Button_min, 7, 600, 0, "Small Fonts")
GUICtrlSetTip($Button_min, "Put the program window in Minimal mode!")
GUICtrlSetResizing($Button_min, $GUI_DOCKALL)
$Label_current = GUICtrlCreateLabel("CURRENT", 290, 36, 65, 18, $SS_CENTER + $SS_CENTERIMAGE + $SS_SUNKEN)
GUICtrlSetFont($Label_current, 6, 600, 0, "Small Fonts")
GUICtrlSetBkColor($Label_current, 0x0000F0)
GUICtrlSetColor($Label_current, 0xFFFFFF)
GUICtrlSetResizing($Label_current, $GUI_DOCKALL)
$Label_size = GUICtrlCreateLabel("", 355, 36, 65, 18, $SS_CENTER + $SS_CENTERIMAGE + $SS_SUNKEN)
GUICtrlSetFont($Label_size, 7, 400, 0, "Small Fonts")
GUICtrlSetResizing($Label_size, $GUI_DOCKALL)
$Label_total = GUICtrlCreateLabel("TOTAL", 430, 36, 45, 18, $SS_CENTER + $SS_CENTERIMAGE + $SS_SUNKEN + $SS_NOTIFY)
GUICtrlSetFont($Label_total, 6, 600, 0, "Small Fonts")
GUICtrlSetBkColor($Label_total, 0x000000)
GUICtrlSetColor($Label_total, 0xFFFFFF)
GUICtrlSetResizing($Label_total, $GUI_DOCKALL)
$Label_sum = GUICtrlCreateLabel("", 475, 36, 65, 18, $SS_CENTER + $SS_CENTERIMAGE + $SS_SUNKEN)
GUICtrlSetFont($Label_sum, 7, 400, 0, "Small Fonts")
GUICtrlSetResizing($Label_sum, $GUI_DOCKALL)
;;;;;;;
$Group_srce = GuiCtrlCreateGroup("Source Path", 20, 50, 455, 60)
GUICtrlSetResizing($Group_srce, $GUI_DOCKALL)
;$Input_srce = GuiCtrlCreateInput("", 30, 58, 385, 20)
$Input_srce = GuiCtrlCreateInput("", 30, 73, 320, 20)
GUICtrlSetState($Input_srce, $GUI_DROPACCEPTED)
GUICtrlSetResizing($Input_srce, $GUI_DOCKALL)
$Checkbox_up = GuiCtrlCreateCheckbox("", 357, 74, 15, 20)
GUICtrlSetTip($Checkbox_up, "Update selected Job name!")
;GUICtrlSetResizing($Checkbox_up, $GUI_DOCKALL)
$Button_set = GuiCtrlCreateButton("SET", 375, 73, 40, 20)
GUICtrlSetFont($Button_set, 7, 600, 0, "Small Fonts")
GUICtrlSetTip($Button_set, "Set Job Name!")
;GUICtrlSetResizing($Button_set, $GUI_DOCKALL)
$Button_sfle = GuiCtrlCreateButton("B", 420, 73, 20, 20, $BS_ICON)
GUICtrlSetTip($Button_sfle, "Browse for source file!")
;GUICtrlSetResizing($Button_sfle, $GUI_DOCKALL)
$Button_sfld = GuiCtrlCreateButton("B", 445, 73, 20, 20, $BS_ICON)
GUICtrlSetTip($Button_sfld, "Browse for source folder!")
;GUICtrlSetResizing($Button_sfld, $GUI_DOCKALL)
;;;;;;;
$Group_wait = GuiCtrlCreateGroup("", 480, 50, 60, 60)
GUICtrlSetResizing($Group_wait, $GUI_DOCKALL)
$Label_wait = GUICtrlCreateLabel("WAIT", 490, 64, 40, 16, $SS_CENTER + $SS_CENTERIMAGE + $SS_SUNKEN)
GUICtrlSetFont($Label_wait, 7, 400, 0, "Small Fonts")
GUICtrlSetBkColor($Label_wait, 0x009000)
GUICtrlSetColor($Label_wait, 0xFFFFFF)
GUICtrlSetResizing($Label_wait, $GUI_DOCKALL)
$Combo_wait = GuiCtrlCreateCombo("", 490, 80, 40, 21)
GUICtrlSetResizing($Combo_wait, $GUI_DOCKALL)
GUICtrlSetTip($Combo_wait, "Minutes to wait before processing current selection!")
;;;;;;;
$Group_dest = GuiCtrlCreateGroup("Destination Path", 20, 120, 520, 60)
$Button_srce = GuiCtrlCreateButton("Source", 150, 117, 55, 18)
GUICtrlSetFont($Button_srce, 7, 600, 0, "Small Fonts")
GUICtrlSetTip($Button_srce, "Add a parent folder from source path!")
$Button_last = GuiCtrlCreateButton("Last", 215, 117, 45, 18)
GUICtrlSetFont($Button_last, 7, 600, 0, "Small Fonts")
GUICtrlSetTip($Button_last, "Retrieve the Last set destination path!")
$Button_change = GuiCtrlCreateButton("Change For All", 280, 117, 100, 18)
GUICtrlSetFont($Button_change, 7, 600, 0, "Small Fonts")
GUICtrlSetTip($Button_change, "Change the destination path of all jobs!")
$Button_process = GuiCtrlCreateButton("Change The Process", 400, 117, 130, 18)
GUICtrlSetFont($Button_process, 7, 600, 0, "Small Fonts")
GUICtrlSetTip($Button_process, "Change the copy/move process of all jobs!")
$Input_dest = GuiCtrlCreateInput("", 30, 143, 350, 21)
GUICtrlSetState($Input_dest, $GUI_DROPACCEPTED)
$Combo_copy = GuiCtrlCreateCombo("", 385, 143, 50, 21)
GUICtrlSetTip($Combo_copy, "Process!")
$Checkbox_ask = GuiCtrlCreateCheckbox("", 440, 143, 15, 20)
GUICtrlSetTip($Checkbox_ask, "Query process on setting first job!")
$Button_sav = GuiCtrlCreateButton("SAVE", 460, 143, 45, 21)
GUICtrlSetFont($Button_sav, 7, 600, 0, "Small Fonts")
GUICtrlSetTip($Button_sav, "Save Job settings!")
$Button_dest = GuiCtrlCreateButton("B", 510, 143, 20, 21, $BS_ICON)
GUICtrlSetTip($Button_dest, "Browse for destination folder!")
;
$Group_job = GuiCtrlCreateGroup("Job Name", 10, 205, 280, 60)
$Combo_job = GuiCtrlCreateCombo("", 20, 228, 217, 21)
GUICtrlSetTip($Combo_job, "Job Name!")
$Button_del = GuiCtrlCreateButton("DEL", 242, 228, 38, 21)
GUICtrlSetFont($Button_del, 7, 600, 0, "Small Fonts")
GUICtrlSetTip($Button_del, "Delete Job Name!")
;
$Group_ord = GuiCtrlCreateGroup("Order", 300, 205, 82, 60)
$Combo_ord = GuiCtrlCreateCombo("", 310, 228, 38, 21)
GUICtrlSetTip($Combo_ord, "Order!")
$Input_ord = GuiCtrlCreateInput("", 352, 228, 20, 21, $ES_NUMBER)
$Updown_ord = GUICtrlCreateUpdown($Input_ord)
GUICtrlSetLimit($Updown_ord, 101, 99)
GUICtrlSetState($Updown_ord, $GUI_ONTOP)
GUICtrlSetTip($Updown_ord, "Set Order!")
;
$Group_delay = GuiCtrlCreateGroup("Delay", 392, 205, 80, 60)
$Button_adv = GuiCtrlCreateButton("AD", 438, 202, 27, 18)
GUICtrlSetFont($Button_adv, 7, 600, 0, "Small Fonts")
GUICtrlSetTip($Button_adv, "Advanced Delay options!")
$Input_delay = GuiCtrlCreateInput("", 402, 228, 35, 20, $ES_NUMBER)
$Updown_delay = GUICtrlCreateUpdown($Input_delay)
GUICtrlSetLimit($Updown_delay, 30, 0)
GUICtrlSetTip($Updown_delay, "Set Delay!")
$Label_delay = GUICtrlCreateLabel("mins", 441, 228, 28, 20, $SS_CENTERIMAGE)
;
$Button_start = GuiCtrlCreateButton("START", 482, 210, 70, 34)
GUICtrlSetFont($Button_start, 9, 600)
GUICtrlSetTip($Button_start, "Start Jobs!")
;
$Checkbox_shut = GuiCtrlCreateCheckbox("Shutdown", 484, 247, 70, 20)
GUICtrlSetTip($Checkbox_shut, "Shutdown!")
;
$Group_fav = GuiCtrlCreateGroup("Favorite Destinations", 10, 275, 340, 60)
$Combo_fav = GuiCtrlCreateCombo("", 20, 298, 265, 21)
GUICtrlSetTip($Combo_fav, "Favorite Destinations!")
$Button_add = GuiCtrlCreateButton("ADD", 295, 298, 45, 20)
GUICtrlSetFont($Button_add, 7, 600, 0, "Small Fonts")
GUICtrlSetTip($Button_add, "Add current destination to favorites list!")
;
$Checkbox_use = GuiCtrlCreateCheckbox("Use Delay", 360, 285, 70, 20)
GUICtrlSetTip($Checkbox_use, "Use Delay!")
;
$Checkbox_thumb = GuiCtrlCreateCheckbox("Delete ALL Thumbs.db", 360, 304, 70, 35, $BS_MULTILINE)
GUICtrlSetTip($Checkbox_thumb, "Delete all Thumbs.db files!")
;~ ;
;~ $Button_start = GuiCtrlCreateButton("START", 360, 265, 70, 55)
;~ GUICtrlSetFont($Button_start, 9, 600)
;~ GUICtrlSetTip($Button_start, "Start Jobs!")
;
$Button_i = GuiCtrlCreateButton("Info", 440, 280, 50, 55, $BS_ICON)
GUICtrlSetTip($Button_i, "Program Information!")
$Button_x = GuiCtrlCreateButton("EXIT", 500, 280, 50, 55, $BS_ICON)
GUICtrlSetTip($Button_x, "Quit, Close or Exit program!")
;
; OS SETTINGS
$shell = @SystemDir & "\shell32.dll"
$user = @SystemDir & "\user32.dll"
$icoF = -85
$icoD = -4
$icoI = -5
If StringLeft(@OSVersion, 5) <> "WIN_9" And @OSVersion <> "WIN_ME" Then
	; WIN_NT4, WIN_2000, WIN_XP, WIN_2003
	$icofle = $shell
	$icoX = -28
Else
	$icofle = $user
	$icoX = -4
EndIf
GUICtrlSetImage($Button_sfle, $icofle, $icoF, 0)
GUICtrlSetImage($Button_sfld, $icofle, $icoD, 0)
GUICtrlSetImage($Button_dest, $icofle, $icoD, 0)
GUICtrlSetImage($Button_i, $user, $icoI, 1)
GUICtrlSetImage($Button_x, $icofle, $icoX, 1)
;
; CONTEXT MENU
$Context_menu = GUICtrlCreateContextMenu($Button_start)
$Item_remove = GUICtrlCreateMenuItem("Remove All Thumbs.db files", $Context_menu, 0, 0)
;
; SETTINGS
$minutes = "0|1|2|3|4|5|6|7|8|9|10|12|15|20|25|30|40|50|60"
GUICtrlSetData($Combo_wait, $minutes, "0")
;
LoadProject()
;
$proc = "copy|move"
If $job = "" Then
	GUICtrlSetData($Combo_copy, $proc, "copy")
Else
	$copy = IniRead($projfle, $job, "process", "")
	GUICtrlSetData($Combo_copy, $proc, $copy)
EndIf
;
$ask = IniRead($inifle, "First Job Process", "ask", "")
If $ask = "" Then
	$ask = 1
	IniWrite($inifle, "First Job Process", "ask", $ask)
EndIf
GUICtrlSetState($Checkbox_ask, $ask)
;
$favs = IniRead($inifle, "Favorites", "names", "")
If $favs = "" Then $favs = "||"
GUICtrlSetData($Combo_fav, $favs)
;
$delay = IniRead($inifle, "Delay", "mins", "")
If $delay = "" Then
	$delay = 3
	IniWrite($inifle, "Delay", "mins", $delay)
EndIf
GUICtrlSetData($Input_delay, $delay)
;
$shut = IniRead($inifle, "Shutdown", "use", "")
If $shut = "" Then
	$shut = 4
	IniWrite($inifle, "Shutdown", "use", $shut)
EndIf
GUICtrlSetState($Checkbox_shut, $shut)
;
$use = IniRead($inifle, "Delay", "use", "")
If $use = "" Then
	$use = 1
	IniWrite($inifle, "Delay", "use", $use)
ElseIf $use = 4 Then
	GUICtrlSetState($Input_delay, $GUI_DISABLE)
	GUICtrlSetState($Updown_delay, $GUI_DISABLE)
	GUICtrlSetState($Button_adv, $GUI_DISABLE)
EndIf
GUICtrlSetState($Checkbox_use, $use)
;
$del = IniRead($inifle, "Thumbs DB Files", "delete", "")
If $del = "" Then
	If @OSVersion = "WIN_XP" Then
		$del = 1
	Else
		$del = 4
	EndIf
	IniWrite($inifle, "Thumbs DB Files", "delete", $del)
EndIf
GUICtrlSetState($Checkbox_thumb, $del)
;
$report = IniRead($inifle, "Thumbs DB Files", "report", "")
If $report = "" Then
	$report = 4
	IniWrite($inifle, "Thumbs DB Files", "report", $report)
EndIf
;
$updwn = 100
GUICtrlSetData($Input_ord, $updwn)
;
$advance = IniRead($inifle, "Delay", "advanced", "")
If $advance = "" Then
	$advance = 4
	IniWrite($inifle, "Delay", "advanced", $advance)
EndIf
If $advance = 1 Then
	GUICtrlSetState($Input_delay, $GUI_DISABLE)
	GUICtrlSetState($Updown_delay, $GUI_DISABLE)
EndIf
;
$double = IniRead($inifle, "Delay", "double", "")
If $double = "" Then
	$double = 4
	IniWrite($inifle, "Delay", "double", $double)
EndIf
;
$pause = IniRead($inifle, "Delay", "pause", "")
If $pause = "" Then
	$pause = 1
	IniWrite($inifle, "Delay", "pause", $pause)
Else
	; Update for Key change name
	$idle = IniRead($inifle, "Delay", "idle", "")
	If $idle = "" Then
		$idle = $pause
		IniWrite($inifle, "Delay", "idle", $idle)
		$pause = 1
		IniWrite($inifle, "Delay", "pause", $pause)
	EndIf
EndIf
;
$idle = IniRead($inifle, "Delay", "idle", "")
If $idle = "" Then
	$idle = 6
	IniWrite($inifle, "Delay", "idle", $idle)
EndIf
;
$above = IniRead($inifle, "Delay", "above", "")
If $above = "" Then
	$above = 14336
	IniWrite($inifle, "Delay", "above", $above)
EndIf
;
$below = IniRead($inifle, "Delay", "before", "")
If $below = "" Then
	$below = 4096
	IniWrite($inifle, "Delay", "before", $below)
EndIf
;
$none = IniRead($inifle, "Delay", "none", "")
If $none = "" Then
	$none = 4
	IniWrite($inifle, "Delay", "none", $none)
EndIf
;
$half = IniRead($inifle, "Delay", "half", "")
If $half = "" Then
	$half = 4
	IniWrite($inifle, "Delay", "half", $half)
EndIf
;
$rest = IniRead($inifle, "Rest Periods", "enable", "")
If $rest = "" Then
	$rest = 4
	IniWrite($inifle, "Rest Periods", "enable", $rest)
EndIf
;
$tasks = IniRead($inifle, "Rest Periods", "jobs", "")
If $tasks = "" Then
	$tasks = 5
	IniWrite($inifle, "Rest Periods", "jobs", $tasks)
EndIf
;
$time = IniRead($inifle, "Rest Periods", "minutes", "")
If $time = "" Then
	$time = 5
	IniWrite($inifle, "Rest Periods", "minutes", $time)
EndIf
;
$remain = IniRead($inifle, "Show On Stop Box", "remain", "")
If $remain = "" Then
	$remain = 1
	IniWrite($inifle, "Show On Stop Box", "remain", $remain)
EndIf
;
$dropped = ""
$mode = "full"
$remove = 4
$advice = ""
;
$combine = IniRead($inifle, "Multiple Drag & Drop", "combine", "")
If $combine = "" Then
	$combine = 4
	IniWrite($inifle, "Multiple Drag & Drop", "combine", $combine)
EndIf
;
$addsolo = IniRead($inifle, "Add To Combine List", "individual", "")
If $addsolo = "" Then
	$addsolo = 4
	IniWrite($inifle, "Add To Combine List", "individual", $addsolo)
EndIf
$addconc = IniRead($inifle, "Add To Combine List", "concenate", "")
If $addconc = "" Then
	$addconc = 4
	IniWrite($inifle, "Add To Combine List", "concenate", $addconc)
EndIf
If $combine = 1 Then
	GUICtrlSetData($Label_add, "CONCENATE")
	GUICtrlSetBkColor($Label_add, 0xF0A000)
	If $addconc = 1 Then
		$how = "ADD To List"
	Else
		$how = ""
	EndIf
ElseIf $addsolo = 1 Then
	$how = "Add To List"
Else
	$how = ""
EndIf
GUICtrlSetData($Combo_how, "||Add To List|New List|View List", $how)
$newlist = ""

GUIRegisterMsg($WM_DROPFILES, "WM_DROPFILES_FUNC")

;Local $event
GuiSetState()
While 1
	$msg = GuiGetMsg()
	;$event = GuiGetMsg(1)
	;$msg = $event[0]
	Select
	Case $msg = $GUI_EVENT_CLOSE Or $msg = $Button_x
		; Quit, Close or Exit program
		$winpos = WinGetPos($TCTimer, "")
		$left = $winpos[0]
		IniWrite($inifle, "Window Position", "left", $left)
		$top = $winpos[1]
		IniWrite($inifle, "Window Position", "top", $top)
		;
		GUIDelete($TCTimer)
		ExitLoop
	Case $msg = $GUI_EVENT_DROPPED
		;MsgBox(262192, "@GUI_DRAGFILE  @GUI_DROPID", @GUI_DRAGFILE  & ":" & @GUI_DROPID, 0)
		;MsgBox(262192, "@GUI_DRAGFILE  @GUI_DROPID", @GUI_DRAGFILE  & ":" & @GUI_DROPID  & @LF & $event[1] & @LF & $event[2], 0, $TCTimer)
		$dropped = @GUI_DROPID
		If $dropped = $Input_srce Then
			If $mode = "minimal" Then
				$paths = ""
				For $p = 0 To UBound($gaDropFiles) - 1
				   $paths &= "|" & $gaDropFiles[$p]
				Next
			Else
				$paths = @GUI_DRAGFILE
			EndIf
		ElseIf $dropped = $Input_dest Then
			$dest = @GUI_DRAGFILE
		Else
			$dropped = ""
		EndIf
		;MsgBox(262192, "Dropped ID", $dropped, 0, $TCTimer)
	Case $dropped <> ""
		; Ensure only one path exists in field (previous is replaced by new, not new inserted).
		If $dropped = $Input_srce Then
			If $mode = "minimal" Then
				;MsgBox(262192, "$combine $addsolo $addconc", $combine & " : " & $addsolo & " : " & $addconc, 0, $TCTimer)
				If ($addconc = 1 And $combine = 1) Or ($addsolo = 1 And $combine = 4) Then
					$combfle = $source
					;MsgBox(262192, "$combfle $job", $combfle & @LF & $job & ".txt", 0, $TCTimer)
					If StringRight($combfle, StringLen($job) + 4) = $job & ".txt" And $newlist = "" Then
						$combsze = IniRead($projfle, $job, "size", "")
					Else
						$combfle = ""
						$job = ""
					EndIf
				Else
					$combfle = ""
					$job = ""
				EndIf
			EndIf
			;MsgBox(262192, "$combfle", $combfle, 0, $TCTimer)
			If StringInStr($paths, "|") > 0 Or $newlist = 1 Then
				$newlist = ""
				;$how = "Add To List"
				;;GUICtrlSetData($Combo_how, "", "")
				;;GUICtrlSetData($Combo_how, "||Add To List|New List|View List", $how)
				;GUICtrlSetData($Combo_how, $how)
				;MsgBox(262192, "$paths", $paths, 0, $TCTimer)
				$paths = StringSplit($paths, "|", 1)
				;If $paths[0] > 2 Then
				;	$how = "Add To List"
				;	GUICtrlSetData($Combo_how, $how)
				;EndIf
				For $p = 2 To $paths[0]
					$source = $paths[$p]
					If $source <> "" Then
						GUICtrlSetData($Input_srce, $source)
						If $remove = 4 Then
							If $mode = "minimal" Then
								$skip = 1
								If $combine = 1 Then
									If $paths[0] > 2 Or $addconc = 1 Then
										AddSourceToCombineList()
									Else
										SetTheJobName()
									EndIf
								Else
									If $addsolo = 1 Then
										AddSourceToCombineList()
									Else
										SetTheJobName()
									EndIf
								EndIf
								If $waiting < 1 Then GUICtrlSetData($Combo_wait, "0")
							EndIf
						EndIf
					EndIf
				Next
			Else
				$source = $paths
				GUICtrlSetData($Input_srce, $source)
				;$source = StringReplace($source, "[", "<")
				;$source = StringReplace($source, "]", ">")
				If $remove = 4 Then
					If $mode = "minimal" Then
						$skip = 1
						SetTheJobName()
					EndIf
					If $waiting < 1 Then GUICtrlSetData($Combo_wait, "0")
				EndIf
			EndIf
		ElseIf $dropped = $Input_dest Then
			$typ = FileGetAttrib($dest)
			If StringInStr($typ, "D") < 1 Then
				$dest = ""
			Else
				;$pth = StringReplace($dest, "[", "<")
				;$pth = StringReplace($pth, "]", ">")
				IniWrite($inifle, "Destination Path", "last", $dest)
				GUICtrlSetState($Button_set, $GUI_ENABLE)
				GUICtrlSetState($Button_min, $GUI_ENABLE)
			EndIf
			GUICtrlSetData($Input_dest, $dest)
		EndIf
		$dropped = ""
	Case $msg = $Button_start
		; START Jobs
		If $remove = 1 Then
			$source = GUICtrlRead($Input_srce)
			If $source <> "" Then
				If FileExists($source) Then
					$ans = MsgBox(262433, "Remove Query", _
						"Do you want to remove all 'Thumbs.db'" & @LF & _
						"files from selected folder & sub-folders?" & @LF & @LF & _
						"OK = Remove (Delete) ALL." & @LF & _
						"CANCEL = Abort removal.", 0, $TCTimer)
					If $ans = 1 Then
						$sline = 0
						$lines = 0
						$thumbs = 0
						$dll = DllOpen("user32.dll")
						GetFolderList($source)
						DllClose($dll)
						MsgBox(262192, "Source Report", "Content = " & $sline & @LF _
							& "Folders = " & $lines & @LF & "Thumbs = " & $thumbs, 6, $TCTimer)
					EndIf
				Else
					MsgBox(262192, "Path Error", "Source path/location does not exist.", 0, $TCTimer)
				EndIf
			Else
				MsgBox(262192, "Path Error", "Source path/location has not been set.", 0, $TCTimer)
			EndIf
		Else
			$tot = IniRead($projfle, "Jobs", "total", "")
			If $tot <> "" Then
				EnableDisableControls($GUI_DISABLE)
				$shut = IniRead($inifle, "Shutdown", "use", "")
				If $shut = 1 Then
					$applied = "Enabled."
				ElseIf $shut = 4 Then
					$applied = "Disabled."
				EndIf
				If $advance = 1 Then
					$advanced = "Enabled."
				ElseIf $advance = 4 Then
					$advanced = "Disabled."
				EndIf
				$stop = ""
				IniWrite($inifle, "Process", "stop", $stop)
				$ans = MsgBox(262177, "Start Query", _
					$tot & " jobs are about to be started." & @LF & @LF & _
					"PC Shutdown afterward is " & $applied & @LF & @LF & _
					"Using Advanced Delay is " & $advanced & @LF & @LF & _
					"To abort this monitoring/timer program," & @LF & _
					"just click the floating STOP button. This" & @LF & _
					"may take a while, depending on the size" & @LF & _
					"of the current TeraCopy job, which must" & @LF & _
					"finish first. You can however, manually" & @LF & _
					"abort TeraCopy to speed things up." & @LF & @LF & _
					"During the Delay period, Stop is checked" & @LF & _
					"for every 10 seconds.", 0, $TCTimer)
				If $ans = 1 Then
					Local $paused, $rem, $remains, $s, $sleep
					_FileWriteLog($logfle, "Started " & $tot & " Jobs")
					WinSetState($TCTimer, "", @SW_MINIMIZE)
					Run($stopfle)
					;ProcessWait("Stop.exe", 5)
					WinWaitActive("[TITLE:_Stop; CLASS:AutoIt v3 GUI]", "", 5)
					$handle = WinGetHandle("[TITLE:_Stop; CLASS:AutoIt v3 GUI]", "")
					$same = ""
					$remlist = ""
					For $j = 1 To $tot
						$paused = ""
						$rem = $tot - $j
						$job = IniRead($projfle, "Jobs", $j, "")
						If $job <> "" Then
							$source = IniRead($projfle, $job, "source", "")
							If $source <> "" Then
								If FileExists($source) Then
									$dest = IniRead($projfle, $job, "destination", "")
									If $dest <> "" Then
										If FileExists($dest) Then
											If FileExists($teracopy) Then
												$waiting = IniRead($projfle, $job, "wait", "0")
												If $waiting > 0 Then
													; Wait for anywhere from 1 minute to 60,
													; with a check for Cancel every 5 seconds.
													; 1 minute = 1 * 60000 milliseconds.
													WinSetTitle($handle, "", "Wait " & $waiting & " (" & $j & ")")
													$mins = $waiting
													$s = 0
													$sleep = $waiting * 60000
													For $s = 0 To $sleep
														Sleep(5000)
														$stop = IniRead($inifle, "Process", "stop", "")
														If $stop = 1 Then
															_FileWriteLog($logfle, "Cancelled at Job " & $j & @CRLF & @CRLF)
															RemoveAfterCancel()
															ExitLoop 2
														EndIf
														$s = $s + 5000
														$remains = Ceiling(($sleep - $s) / 60000)
														If $remains < $mins Then
															$mins = $remains
															WinSetTitle($handle, "", "Wait " & $mins & " (" & $j & ")")
														EndIf
													Next
												EndIf
												$as = ""
												If StringLeft($job, 14) = "Combine List _" Then
													If StringIsDigit(StringReplace($job, "Combine List _", "")) = 1 Then
														$as = "*"
													EndIf
												EndIf
												If $as = "" Then
													SourceGetSize(0)
												Else
													$bytes = IniRead($projfle, $job, "size", "")
													$mbs = $bytes / 1048576
													If $mbs > 1024 Then
														$size = $mbs / 1024
														$size = Round($size, 2) & " Gb's"
													Else
														$size = Round($mbs, 2) & " Mb's"
													EndIf
												EndIf
												$copy = IniRead($projfle, $job, "process", "")
												_FileWriteLog($logfle, $job & " started (" & $copy & ") " & $size)
												If $copy = "move" Then
													$copy = ' Move "'
												ElseIf $copy = "copy" Then
													$copy = ' Copy "'
												EndIf
												If $remain = 1 Then
													;WinSetTitle($handle, "", "_Stop (" & $rem & ")")
													If $tot < 100 Then
														WinSetTitle($handle, "", $j & " of " & $tot & " now")
													Else
														WinSetTitle($handle, "", $j & " of " & $tot)
													EndIf
												Else
													WinSetTitle($handle, "", "_Stop (" & $j & ")")
												EndIf
												If $del = 1 Then
													$sline = 0
													$lines = 0
													$thumbs = 0
													$dll = DllOpen("user32.dll")
													If $as = "" Then
														GetFolderList($source)
													Else
														$thmbs = 0
														_FileReadToArray($source, $array)
														If @error = 0 Then
															For $a = 1 To $array[0]
																$srce = $array[$a]
																If $srce <> "" Then
																	GetFolderList($srce)
																	$thmbs += $thumbs
																EndIf
															Next
														EndIf
														$thumbs = $thmbs
													EndIf
													DllClose($dll)
													If $report = 1 Then
														MsgBox(262192, "Source Report", "Content = " & $sline & @LF _
															& "Folders = " & $lines & @LF & "Thumbs = " & $thumbs, 6, $TCTimer)
													EndIf
												EndIf
												If StringLeft($source, 1) = StringLeft($dest, 1) Then $same = 1
												If $same = 1 Then
													$doit = ""
													$ans = MsgBox(262179, "Path Query", _
														"(continuing with YES in 20 seconds)" & @LF & @LF & _
														"The program has detected that the drive for" & @LF & _
														"current source and destination are the same." & @LF & @LF & _
														$source & @LF & _
														$dest & @LF & @LF & _
														"ADVICE - This could be due to some unnoticed" & @LF & _
														"change in drive letters, with removable drives." & @LF & @LF & _
														"Do you really want to continue anyway?" & @LF & @LF & _
														"YES = Do the job anyway." & @LF & _
														"NO = Just skip the current job." & @LF & _
														"CANCEL = Cancel all further jobs.", 20, $TCTimer)
													If $ans = 6 Then
														; Do the job anyway.
														$doit = 1
													ElseIf $ans = 7 Then
														; Just skip current job.
													ElseIf $ans = 2 Then
														; Cancel any further jobs.
														ExitLoop
													EndIf
												Else
													$doit = 1
												EndIf
												If $doit = 1 Then
													RunWait($teracopy & $copy & $as & $source & '" "' & $dest & '" /SkipAll /Close')
													_FileWriteLog($logfle, $job & " finished")
													$stop = IniRead($inifle, "Process", "stop", "")
													If $stop = 1 Then
														_FileWriteLog($logfle, "Cancelled" & @CRLF & @CRLF)
														RemoveAfterCancel()
														ExitLoop
													EndIf
													If $j = $tot Then
														; All jobs completed, so display usual remove query.
														$remlist = ""
													Else
														; Create a removal list, in case cancel occurs before all jobs are completed.
														If $remlist = "" Then
															$remlist = $job
														Else
															$remlist = $remlist & "|" & $job
														EndIf
													EndIf
												EndIf
											Else
												MsgBox(262192, "Program Error", _
													"TeraCopy is required to use this program frontend." & @LF & @LF & _
													"Both a Free and Pro version can be found on the" & @LF & _
													"web - www.codesector.com", 0, $TCTimer)
											EndIf
										EndIf
									EndIf
								EndIf
							EndIf
						EndIf
						If $doit = 1 Then
							If $j < $tot Then
								; Check for Rest Period
								If $rest = 1 Then
									If $tasks > 0 And $time > 0 Then
										If StringIsDigit($j / $tasks) Then
											IniWrite($inifle, "Rest Period", "started", _NowCalc())
											$paused = 1
											For $b = 1 To $time
												For $d = 1 To 6
													; Sleep for 10 seconds, then check for stop.
													Sleep(10000)
													$stop = IniRead($inifle, "Process", "stop", "")
													If $stop = 1 Then
														$ans = MsgBox(262193, "Exit Query", _
															"OK = Stop processing  ALL jobs & Exit." & @LF & @LF & _
															"CANCEL = Exit from Rest Period only," & @LF & _
															"and continue with any remaining jobs.", 0, $TCTimer)
														If $ans = 1 Then
															_FileWriteLog($logfle, "Cancelled" & @CRLF & @CRLF)
															RemoveAfterCancel()
															ExitLoop 3
														ElseIf $ans = 2 Then
															IniWrite($inifle, "Process", "stop", "")
															ExitLoop 2
														EndIf
													EndIf
												Next
											Next
											IniWrite($inifle, "Rest Period", "stopped", _NowCalc())
										EndIf
									EndIf
								EndIf
							EndIf
							If $paused = 1 Then
								; Rest Period occurred so skip further delaying.
								$stop = IniRead($inifle, "Process", "stop", "")
								If $stop = 1 Then
									_FileWriteLog($logfle, "Cancelled" & @CRLF & @CRLF)
									RemoveAfterCancel()
									ExitLoop
								EndIf
							Else
								If $delay > 0 And $use = 1 And $j <> $tot Then
									If $advance = 1 And $mbs > $above Then
										; Advanced Delay is set and size is greater than above.
										If $double = 1 Then
											; Double the Standard delay
											$wait = $delay * 2
										Else
											; Use the Above delay
											$wait = $idle
										EndIf
									ElseIf $advance = 1 And $mbs < $below Then
										; Advanced Delay is set and size is less than below.
										If $none = 1 Then
											; No delay
											$wait = 0
										Else
											If $half = 1 And $mbs < ($below / 2) Then
												; No delay
												$wait = 0
											Else
												; Use the Below delay
												$wait = $pause
											EndIf
										EndIf
									Else
										; Standard delay
										$wait = $delay
									EndIf
									If $wait > 0 Then
										For $e = 1 To $wait
											For $f = 1 To 6
												; Sleep for 10 seconds, then check for stop.
												Sleep(10000)
												$stop = IniRead($inifle, "Process", "stop", "")
												If $stop = 1 Then
													$ans = MsgBox(262193, "Exit Query", _
														"OK = Stop processing  ALL jobs & Exit." & @LF & @LF & _
														"CANCEL = Exit from Delay Period only," & @LF & _
														"and continue with any remaining jobs.", 0, $TCTimer)
													If $ans = 1 Then
														_FileWriteLog($logfle, "Cancelled" & @CRLF & @CRLF)
														RemoveAfterCancel()
														ExitLoop 3
													ElseIf $ans = 2 Then
														IniWrite($inifle, "Process", "stop", "")
														ExitLoop 2
													EndIf
												EndIf
											Next
										Next
									EndIf
								EndIf
							EndIf
						EndIf
					Next
					If ProcessExists("STOP.EXE") Then
						ProcessClose("STOP.EXE")
					EndIf
					WinSetState($TCTimer, "", @SW_RESTORE)
					If $stop = "" Then
						_FileWriteLog($logfle, "Finished All Jobs" & @CRLF & @CRLF)
					EndIf
					If $same = 1 Then
						MsgBox(262192, "Advisory Only - Jobs Completed", _
							"Please ignore the following if situation was deliberate." & @LF & @LF & _
							"This program did detect that the drive for one job at" & @LF & _
							"least, was the same for both source and destination." & @LF & @LF & _
							"ADVICE - This could likely be due to some unnoticed" & @LF & _
							"change in drive letters, with removable drives. This" & @LF & _
							"may mean source(s) was copied or moved wrongly," & @LF & _
							"to an undesired destination.", 0, $TCTimer)
					Else
						; 1 = Shutdown. 4 = Force. 8 = Power down. 16 = Force if hung. 1 + 4 + 8 = 13. 13 + 16 = 29.
						$shut = IniRead($inifle, "Shutdown", "use", "")
						If $shut = 1 And $stop = "" Then
							$ans = MsgBox(262449, "Shutdown Query", _
								"All the specified/listed jobs have finished." & @LF & @LF & _
								"Do you want to continue with PC Shutdown?" & @LF & @LF & _
								"NOTE - This dialog appears for 90 seconds," & @LF & _
								"after which, if CANCEL is not clicked, then" & @LF & _
								"Shutdown will be assumed.", 90, $TCTimer)
							If $ans = 1 Or $ans = -1 Then
								;MsgBox(262192, "Shutdown", "Result.", 0)
								GUIDelete($TCTimer)
								Shutdown(29)
								ExitLoop
							ElseIf $ans = 2 Then
								ContinueLoop
							EndIf
						EndIf
					EndIf
					If $remlist = "" Then
						RemoveQuery()
						ClearQuery()
					Else
						$remlist = ""
					EndIf
				ElseIf $ans = 2 Then
					ContinueLoop
				EndIf
				EnableDisableControls($GUI_ENABLE)
			Else
				MsgBox(262192, "Jobs Error", "Does not appear to be any jobs set.", 0, $TCTimer)
			EndIf
		EndIf
	Case $msg = $Button_srce
		; Add a parent folder from source path
		$source = GUICtrlRead($Input_srce)
		If $source <> "" Then
			$dest = GUICtrlRead($Input_dest)
			If $dest <> "" Then
				$subs = StringSplit($source, "\")
				If $subs[0] > 2 Then
					$sub_1 = $subs[0] - 1
					$sub_1 = $subs[$sub_1]
					$sub_1 = "\" & $sub_1
					If $subs[0] > 3 Then
						$sub_2 = $subs[0] - 2
						$sub_2 = $subs[$sub_2]
						$sub_2 = "\" & $sub_2
						$sub = $sub_2 & $sub_1
						If StringRight($dest, StringLen($sub)) = $sub Then
							; Back to original destination
							$dest = StringTrimRight($dest, StringLen($sub))
						ElseIf StringRight($dest, StringLen($sub_1)) = $sub_1 Then
							; Use last two parent sub folders
							$dest = StringTrimRight($dest, StringLen($sub_1))
							$dest = $dest & $sub
;~ 						ElseIf StringRight($dest, StringLen($sub_2)) = $sub_2 Then
;~ 							$dest = StringTrimRight($dest, StringLen($sub_2))
						Else
							$dest = $dest & $sub_1
						EndIf
					Else
						If StringRight($dest, StringLen($sub_1)) = $sub_1 Then
							$dest = StringTrimRight($dest, StringLen($sub_1))
						Else
							$dest = $dest & $sub_1
						EndIf						
					EndIf
					GUICtrlSetData($Input_dest, $dest)
				Else
					MsgBox(262192, "Source Error", "Not enough sub-folders.", 0, $TCTimer)
				EndIf
			Else
				MsgBox(262192, "Path Error", "Destination path/location has not been set.", 0, $TCTimer)
			EndIf
		Else
			MsgBox(262192, "Path Error", "Source path/location has not been set.", 0, $TCTimer)
		EndIf
	Case $msg = $Button_sfle
		; Browse for source file
		WinSetOnTop($TCTimer, "", 0)
		$pth = FileOpenDialog("Select a source file to copy/move.", "", "All Files (*.*)", 3, $source, $TCTimer)
		If @error <> 1 And $pth <> "" And StringMid($pth, 2, 2) = ":\" Then
			$source = $pth
			GUICtrlSetData($Input_srce, $source)
		EndIf
		WinSetOnTop($TCTimer, "", 1)
	Case $msg = $Button_sfld
		; Browse for source folder
		WinSetOnTop($TCTimer, "", 0)
		$pth = FileSelectFolder("Select a source folder to copy/move.", "", 6, $source, $TCTimer)
		If @error <> 1 And $pth <> "" And StringMid($pth, 2, 2) = ":\" Then
			$source = $pth
			GUICtrlSetData($Input_srce, $source)
		EndIf
		WinSetOnTop($TCTimer, "", 1)
	Case $msg = $Button_set
		; Set Job Name
		If _IsPressed("11") Then
			$skip = 1
		Else
			$skip = 4
		EndIf
		SetTheJobName()
	Case $msg = $Button_sav
		; Save Job settings
		If _IsPressed("11") Then
			ClearQuery()
		Else
			$job = GUICtrlRead($Combo_job)
			If $job <> "" Then
				$dest = GUICtrlRead($Input_dest)
				If $dest <> "" Then
					SaveJobSettings()
				Else
					MsgBox(262192, "Path Error", "Destination path/location has not been set.", 0, $TCTimer)
				EndIf
			Else
				MsgBox(262192, "Job Error", "A job name has not been set.", 0, $TCTimer)
			EndIf
		EndIf
	Case $msg = $Button_process
		; Change the copy/move process of all jobs
		$ans = MsgBox(262691, "Change The Process", _
			"Do you want to change the Copy or Move" & @LF & _
			"process for ALL listed jobs?" & @LF & @LF & _
			"YES = Change to COPY." & @LF & _
			"NO = Change to MOVE." & @LF & @LF & _
			"CANCEL = Abort any change." & @LF & @LF & _
			"WARNING = This will change the process" & @LF & _
			"for all, regardless of any difference that" & @LF & _
			"exists for destination paths.", 0, $TCTimer)
		If $ans <> 2 Then
			If $ans = 6 Then
				$copy = "copy"
			ElseIf $ans = 7 Then
				$copy = "move"
			EndIf
			$tot = IniRead($projfle, "Jobs", "total", "")
			If $tot <> "" Then
				For $j = 1 To $tot
					$job = IniRead($projfle, "Jobs", $j, "")
					If $job <> "" Then
						IniWrite($projfle, $job, "process", $copy)
					EndIf
				Next
				GUICtrlSetData($Combo_copy, $copy)
			Else
				MsgBox(262192, "Change Error", "No jobs are listed.", 0, $TCTimer)
			EndIf
		EndIf
	Case $msg = $Button_min
		; Put the program window in Minimal or Full mode
		If GUICtrlRead($Button_min) = "MIN" Then
			$mode = "minimal"
			GUICtrlSetData($Button_min, "MAX")
			GUICtrlSetTip($Button_min, "Put the program window in Full size mode!")
			;
			GUICtrlSetBkColor($Label_multi, 0x00D000)
			GUICtrlSetData($Label_multi, "Multiple File && Folder Support = ENABLED")
			If $combine = 1 Then
				GUICtrlSetData($Label_add, "CONCENATE")
				GUICtrlSetBkColor($Label_add, 0xF0A000)
			EndIf
			;
			SetControlsState($GUI_HIDE)
			;
			GUICtrlSetPos($Button_comb, 370, 3, 65, 21)
			GUICtrlSetData($Button_comb, "Combine")
			GUICtrlSetTip($Button_comb, "Disable or Enable the Combining of multiple files!")
			;
			GUICtrlSetPos($Label_current, 180, 36)
			GUICtrlSetPos($Label_size, 245, 36)
			GUICtrlSetPos($Label_total, 315, 36)
			GUICtrlSetPos($Label_sum, 360, 36)
			;GUICtrlSetPos($Group_srce, 20, 35, 405, 60)
			GUICtrlSetPos($Group_srce, 20, 50, 340, 60)
			GUICtrlSetPos($Group_wait, 365, 50, 60, 60)
			GUICtrlSetPos($Label_wait, 375, 64, 40, 16)
			GUICtrlSetPos($Combo_wait, 375, 80, 40, 21)
			GUICtrlSetPos($Group_pths, 10, 25, 425, 100)
			;
			$winsize = WinGetClientSize($TCTimer, "")
			If @error = 1 Then
				$width = ""
				$height = ""
			Else
				$width = $winsize[0]
				$height = $winsize[1]
				WinMove($TCTimer, "", Default, Default, 450, 170)
			EndIf
			;
			If $advice = "" Then
				$advice = 1
				MsgBox(262192, "Process Advice", _
					"When the program window is in Minimal size mode," & @LF & _
					"any sources dragged & dropped, are immediately" & @LF & _
					"set using the defaults for Job name & destination." & @LF & @LF & _
					"Current setting for Copy or Move process will be" & @LF & _
					"used for all future jobs added while in this mode," & @LF & _
					"unless adding the first job, when set by a query." & @LF & @LF & _
					"To see this information again, when using the MIN" & @LF & _
					"button, restart the program. Or it is duplicated on" & @LF & _
					"one of the extra 'Program Information' windows.", 0, $TCTimer)
			EndIf
		Else
			$mode = "full"
			GUICtrlSetData($Button_min, "MIN")
			GUICtrlSetTip($Button_min, "Put the program window in Minimal mode!")
			;
			GUICtrlSetBkColor($Label_multi, 0xF00000)
			GUICtrlSetData($Label_multi, "Multiple File && Folder Support = DISABLED")
			;
			If $width <> "" And $height <> "" Then
				; Original = 560 (w), 335 (h)
				WinMove($TCTimer, "", Default, Default, $width, $height)
				$winsize = WinGetClientSize($TCTimer, "")
				If $width <> $winsize[0] Or $height <> $winsize[1] Then
					$width = $width + ($width - $winsize[0])
					$height = $height + ($height - $winsize[1])
					WinMove($TCTimer, "", Default, Default, $width, $height)
				EndIf
			EndIf
			;
			GUICtrlSetPos($Group_pths, 10, 25, 540, 170)
			GUICtrlSetPos($Group_wait, 480, 50, 60, 60)
			GUICtrlSetPos($Label_wait, 490, 64, 40, 16)
			GUICtrlSetPos($Combo_wait, 490, 80, 40, 21)
			GUICtrlSetPos($Group_srce, 20, 50, 455, 60)
			GUICtrlSetPos($Label_sum, 475, 36)
			GUICtrlSetPos($Label_total, 430, 36)
			GUICtrlSetPos($Label_size, 355, 36)
			GUICtrlSetPos($Label_current, 290, 36)
			;Project
			GUICtrlSetPos($Button_comb, 220, 3, 100, 21)
			GUICtrlSetData($Button_comb, "LOAD or NEW")
			GUICtrlSetTip($Button_comb, "Load or Create a Project!")
			;
			SetControlsState($GUI_SHOW)
		EndIf
	Case $msg = $Button_last
		; Retrieve the Last set destination path
		$dest = IniRead($inifle, "Destination Path", "last", "")
		If _IsPressed("11") And $dest <> "" Then
			; Clear last stored destination path or Reset to new
			If $dest = GUICtrlRead($Input_dest) Then
				; Clear last stored destination path
				GUICtrlSetData($Input_dest, "")
				$dest = ""
				GUICtrlSetState($Button_set, $GUI_DISABLE)
				GUICtrlSetState($Button_min, $GUI_DISABLE)
			Else
				; Reset to new
				$dest = GUICtrlRead($Input_dest)
			EndIf
			IniWrite($inifle, "Destination Path", "last", $dest)
		Else
			If $dest <> "" Then
				If Not FileExists($dest) Then
					; NOTE - Consider doing a drive letter check, and different response if not exist,
					; due to it having been an obvious removable HDD, that could be connected again.
					$ans = MsgBox(262449, "Wipe Query", _
						"The Last recorded Destination path, does not currently exist." & @LF & @LF & _
						$dest & @LF & @LF & _
						"Do you want to delete (remove) it from the record?", 0, $TCTimer)
					If $ans = 1 Then
						IniWrite($inifle, "Destination Path", "last", "")
					EndIf
					$dest = ""
				Else
					GUICtrlSetData($Input_dest, $dest)
				EndIf
			EndIf
			If $dest = "" Then
				GUICtrlSetState($Button_set, $GUI_DISABLE)
				GUICtrlSetState($Button_min, $GUI_DISABLE)
			Else
				GUICtrlSetState($Button_set, $GUI_ENABLE)
				GUICtrlSetState($Button_min, $GUI_ENABLE)
			EndIf
		EndIf
	Case $msg = $Button_i
		; Program Information
		$ans = MsgBox(262465, "Program Information", _
			"This program is a frontend for the program TeraCopy, and it allows you to" & @LF & _
			"use a delay between TeraCopy jobs, that you have setup in this program." & @LF & @LF & _
			"To remove a Favorite, just select that entry, then hold down CTRL while" & @LF & _
			"clicking the ADD button." & @LF & @LF & _
			"To remove ALL Jobs, just hold down CTRL while clicking the DEL button." & @LF & @LF & _
			"To clear the Source and Destination fields, just hold down CTRL while" & @LF & _
			"clicking the SAVE button." & @LF & @LF & _
			"To wipe the last stored Destination path or reset to current input value," & @LF & _
			"just hold down CTRL key while clicking the LAST button." & @LF & @LF & _
			"To skip the 'Same Destination' query, just hold down CTRL while clicking" & @LF & _
			"the SET button. It also skips the Job name query and goes with default." & @LF & @LF & _
			"Order of Job processing can be checked, either by name or number, plus" & @LF & _
			"the order number can be changed using the up/down button." & @LF & @LF & _
			"Enabling the Shutdown option, will turn off computer after all jobs finish," & @LF & _
			"but allows you a 90 second opportunity with dialog, to manually cancel." & @LF & @LF & _
			"A floating STOP button after Start, allows you to abort Job processing," & @LF &  _
			"plus gives access to Enabling/Disabling the Shutdown setting. It can take" & @LF & _
			"up to 10 seconds before a STOP is acted upon during any pause." & @LF & @LF & _
			"This program also supports drag and drop for the source and destination" & @LF & _
			"paths, to those fields." & @LF & @LF & _
			"If a destination does not exist, you will be prompted on SAVE, to have it" & @LF & _
			"created. This could be because you typed it or used the SOURCE button" & @LF & _
			"(which toggles between last two source sub-folder variations & original)." & @LF & @LF & _
			"Click OK to see more information, etc.", 0, $TCTimer)
		If $ans = 1 Then
			$ans = MsgBox(262465, "Program Information (cont.)", _
				"Thanks to Lazycat (at AF) for his 'Drop multiple files on any control'" & @LF & _
				"example in the AutoIt Example Scripts forum, from June 23, 2006." & @LF & @LF & _
				"This START button has a right-click context menu entry, that allows" & @LF & _
				"for just the removal (deletion) of ALL Thumbs.db files from source." & @LF & @LF & _
				"[Process Advice]" & @LF & _
				"When the program window is in Minimal size mode," & @LF & _
				"any sources dragged & dropped, are immediately" & @LF & _
				"set using the defaults for Job name & destination." & @LF & _
				"Current setting for Copy or Move process will be" & @LF & _
				"used for all future jobs added while in this mode," & @LF & _
				"unless adding the first job, when set by a query." & @LF & @LF & _
				" April 2014 by TheSaint  (latest update in November 2019)." & @LF & @LF & _
				"Click OK to view the Report Log.", 0, $TCTimer)
			If $ans = 1 Then Run(@WindowsDir & "\Notepad.exe " & $logfle)
		EndIf
	Case $msg = $Button_dest
		; Browse for destination folder
		WinSetOnTop($TCTimer, "", 0)
		$pth = FileSelectFolder("Select a destination folder for copy/move.", "", 7, $dest, $TCTimer)
		If @error <> 1 And $pth <> "" And StringMid($pth, 2, 2) = ":\" Then
			$dest = $pth
			GUICtrlSetData($Input_dest, $dest)
			GUICtrlSetState($Button_set, $GUI_ENABLE)
			IniWrite($inifle, "Destination Path", "last", $dest)
			GUICtrlSetState($Button_min, $GUI_ENABLE)
		EndIf
		WinSetOnTop($TCTimer, "", 1)
	Case $msg = $Button_del
		; Delete Job Name
		If _IsPressed("11") Then
			; Query delete all
			RemoveQuery()
			ClearQuery()
		Else
			$job = GUICtrlRead($Combo_job)
			If $job <> "" Then
				$ans = MsgBox(262193, "Remove Query", _
					"Are you sure you want the currently selected" & @LF & _
					"job and its settings, to be deleted/removed?" & @LF & @LF & _
					"WARNING - The Copy or Move setting will not" & @LF & _
					"be changed, so may not be what you desire." & @LF & _
					"Whatever is currently shown, will be default.", 0, $TCTimer)
				If $ans = 1 Then
					If StringInStr($jobs, "|" & $job & "|") > 0 Then
						$jobs = StringReplace($jobs, "|" & $job & "|", "|")
						IniWrite($projfle, "Jobs", "names", $jobs)
						GUICtrlSetData($Combo_job, "", "")
						GUICtrlSetData($Combo_job, $jobs, "")
						$n = IniRead($projfle, $job, "order", "")
						$tot = IniRead($projfle, "Jobs", "total", $tot)
						$nums = "|"
						For $t = 1 To $tot
							If $t < $tot Then
								$nums = $nums & "|" & $t
								If $t >= $n Then
									$tmp = IniRead($projfle, "Jobs", $t + 1, "")
									IniWrite($projfle, "Jobs", $t, $tmp)
									IniWrite($projfle, $tmp, "order", $t)
								EndIf
							Else
								IniDelete($projfle, "Jobs", $tot)
							EndIf
						Next
						$tot = $tot - 1
						IniWrite($projfle, "Jobs", "total", $tot)
						If $tot > 0 Then
							GUICtrlSetData($Group_pths, "Job Paths  (" & $tot & ")")
						Else
							GUICtrlSetData($Group_pths, "Job Paths")
						EndIf
						If StringLeft($job, 14) = "Combine List _" Then
							If StringIsDigit(StringReplace($job, "Combine List _", "")) = 1 Then
								$combfle = IniRead($projfle, $job, "source", "")
								If FileExists($combfle) Then
									If StringRight($combfle, 4) = ".txt" Then
										If StringInStr($combfle, "Combine List _") > 0 Then
											FileDelete($combfle)
										EndIf
									EndIf
								EndIf
							EndIf
						EndIf
						IniDelete($projfle, $job)
						GUICtrlSetData($Combo_ord, "", "")
						GUICtrlSetData($Combo_ord, $nums, "")
						;
						; This has caused issues, so skipped now and a Warning given above.
						;GUICtrlSetData($Combo_copy, "", "")
						;GUICtrlSetData($Combo_copy, $proc, "copy")
						;
						GUICtrlSetData($Label_size, "")
						GetTotalSize()
						ClearQuery()
					EndIf
				EndIf
			Else
				MsgBox(262192, "Job Error", "A job name has not been selected.", 0, $TCTimer)
			EndIf
		EndIf
	Case $msg = $Button_comb
		; Disable or Enable the Combining of multiple files
		If GUICtrlRead($Button_comb) = "LOAD or NEW" Then
			$ans = MsgBox(262435, "Project Query", _
				"Do you want to load a prior project?" & @LF & @LF & _
				"YES = Load a prior project." & @LF & _
				"NO = Create a new project. *" & @LF & @LF & _
				"CANCEL = Abort." & @LF & @LF & _
				"NOTE - Creating a new project is an" & @LF & _
				"automatic date based file name. Any" & @LF & _
				"current project file is just unloaded," & @LF & _
				"and can be selected (loaded) again" & @LF & _
				"at any time. * The project file is not" & @LF & _
				"created until the first job is added.", 0, $TCTimer)
			If $ans = 6 Then
				WinSetOnTop($TCTimer, "", 0)
				$pth = FileOpenDialog("Select a project file to use.", $projects, "Projects (*.ini)", 3, $projfle, $TCTimer)
				If @error <> 1 And $pth <> "" And StringMid($pth, 2, 2) = ":\" Then
					$projfle = $pth
					IniWrite($inifle, "Last Project", "file", $projfle)
					GUICtrlSetData($Group_pths, "Job Paths")
					GUICtrlSetData($Combo_job, "", "")
					GUICtrlSetData($Combo_ord, "", "")
					GUICtrlSetData($Combo_copy, "", "")
					GUICtrlSetData($Label_size, "")
					GUICtrlSetData($Label_sum, "")
					LoadProject()
				EndIf
				WinSetOnTop($TCTimer, "", 1)
			ElseIf $ans = 7 Then
				GetSetProjectFile(1)
				;$addconc = 4
				;$addsolo = 4
				$combfle = ""
				;$how = ""
				$job = ""
				$jobs = "||"
				$newlist = ""
				$nums = "|"
				$source = ""
				$tot = 0
				$total = "sum"
				;IniWrite($inifle, "Add To Combine List", "concenate", $addconc)
				;IniWrite($inifle, "Add To Combine List", "individual", $addsolo)
				;GUICtrlSetData($Combo_how, "||Add To List|New List|View List", $how)
				GUICtrlSetData($Input_srce, "")
				GUICtrlSetData($Group_pths, "Job Paths")
				GUICtrlSetData($Combo_job, "", "")
				GUICtrlSetData($Combo_job, $jobs, "")
				GUICtrlSetData($Combo_ord, "", "")
				GUICtrlSetData($Combo_ord, $nums, "")
				GUICtrlSetData($Combo_copy, "", "")
				GUICtrlSetData($Combo_copy, $proc, "copy")
				GUICtrlSetData($Label_size, "")
				GUICtrlSetData($Label_sum, "")
			ElseIf $ans = 2 Then
				; Abort
			EndIf
		ElseIf GUICtrlRead($Button_comb) = "Combine" Then
			If $combine = 1 Then
				$combine = 4
				GUICtrlSetData($Label_add, "INDIVIDUAL")
				GUICtrlSetBkColor($Label_add, 0xF000F0)
				If $addsolo = 1 Then
					$how = "Add To List"
				Else
					$how = ""
				EndIf
			Else
				$combine = 1
				GUICtrlSetData($Label_add, "CONCENATE")
				GUICtrlSetBkColor($Label_add, 0xF0A000)
				If $addconc = 1 Then
					$how = "Add To List"
				Else
					$how = ""
				EndIf
			EndIf
			GUICtrlSetData($Combo_how, "||Add To List|New List|View List", $how)
			IniWrite($inifle, "Multiple Drag & Drop", "combine", $combine)
		EndIf
	Case $msg = $Button_change
		; Change the destination path of all jobs
		If $projfle = "" Then
			MsgBox(262192, "Project Error", "Project file has not been set!", 0, $TCTimer)
		Else
			DropboxGUI()
		EndIf
	Case $msg = $Button_adv
		; Advanced Delay options
		AdvancedDelayOpts()
	Case $msg = $Button_add
		; Add current destination to favorites list
		If _IsPressed("11") Then
			; REMOVE
			$job = GUICtrlRead($Combo_fav)
			If $job <> "" Then
				If StringInStr($favs, "|" & $job & "|") > 0 Then
					$fixnum = ""
					$fv = StringSplit($favs, "|")
					$cnt = $fv[0] - 1
					For $n = 1 To $cnt
						$num = $n - 2
						$fav = $fv[$n]
						If $fav = $job Then
							;MsgBox(262192, "$n $fv[0]", $n & ":" & $cnt, 0)
							IniWrite($inifle, "Favorites", $num, "")
							$favs = StringReplace($favs, "|" & $job & "|", "|")
							IniWrite($inifle, "Favorites", "names", $favs)
							$fixnum = 1
						Else
							If $fixnum = 1 Then
								$fav = IniRead($inifle, "Favorites", $num, "")
								IniWrite($inifle, "Favorites", $num - 1, $fav)
							EndIf
						EndIf
						If $n = $cnt Then
							IniDelete($inifle, "Favorites", $num)
							GUICtrlSetData($Combo_fav, "", "")
							GUICtrlSetData($Combo_fav, $favs, "")
							ExitLoop
						EndIf
					Next
				EndIf
			Else
				MsgBox(262192, "Remove Error", "A name has not been selected.", 0, $TCTimer)
			EndIf
		Else
			; ADD
			$job = GUICtrlRead($Combo_job)
			If $job <> "" Then
				$dest = GUICtrlRead($Input_dest)
				If $dest = "" Then
					MsgBox(262192, "Job Error", "Destination has not been set or selected.", 0, $TCTimer)
				Else
					If StringInStr($favs, "|" & $job & "|") < 1 Then
						; Job is not in favorites yet.
						$favs = $favs & $job & "|"
						IniWrite($inifle, "Favorites", "names", $favs)
						$n = StringSplit($favs, "|")
						$n = $n[0] - 3
						IniWrite($inifle, "Favorites", $n, $dest)
						GUICtrlSetData($Combo_fav, "", "")
						GUICtrlSetData($Combo_fav, $favs, $job)
					Else
						; Update destination path for currently specified/selected favorite Job.
						$fav = StringSplit($favs, "|")
						For $n = 1 To $fav[0]
							If $fav[$n] = $job Then
								If $dest <> IniRead($inifle, "Favorites", $n - 2, "") Then
									; Query updating the Destination path.
									$ans = MsgBox(262449, "Update Query", _
										"The Job name currently exists in Favorites," & @LF & _
										"but has a different destination assigned." & @LF & @LF & _
										"Do you want to update to the new one?", 0, $TCTimer)
									If $ans = 1 Then
										IniWrite($inifle, "Favorites", $n - 2, $dest)
									EndIf
								EndIf
							EndIf
						Next
					EndIf
				EndIf
			Else
				MsgBox(262192, "Job Error", "A job name has not been set.", 0, $TCTimer)
			EndIf
		EndIf
	Case $msg = $Checkbox_use
		; Use Delay
		If GUICtrlRead($Checkbox_use) = $GUI_CHECKED Then
			$use = 1
			GUICtrlSetState($Input_delay, $GUI_ENABLE)
			GUICtrlSetState($Updown_delay, $GUI_ENABLE)
			GUICtrlSetState($Button_adv, $GUI_ENABLE)
		Else
			$use = 4
			GUICtrlSetState($Input_delay, $GUI_DISABLE)
			GUICtrlSetState($Updown_delay, $GUI_DISABLE)
			GUICtrlSetState($Button_adv, $GUI_DISABLE)
			If $advance = 1 Then
				$advance = 4
				IniWrite($inifle, "Delay", "advanced", $advance)
			EndIf
		EndIf
		IniWrite($inifle, "Delay", "use", $use)
	Case $msg = $Checkbox_up
		; Update selected Job name
		If GUICtrlRead($Checkbox_up) = $GUI_CHECKED Then
			$up = 1
			GUICtrlSetData($Button_set, "UP")
			GUICtrlSetTip($Button_set, "Update Source Path!")
		Else
			$up = 4
			GUICtrlSetData($Button_set, "SET")
			GUICtrlSetTip($Button_set, "Set Job Name!")
		EndIf
	Case $msg = $Checkbox_shut
		; Shutdown
		If GUICtrlRead($Checkbox_shut) = $GUI_CHECKED Then
			$shut = 1
		Else
			$shut = 4
		EndIf
		IniWrite($inifle, "Shutdown", "use", $shut)
	Case $msg = $Checkbox_ask
		; Query process on setting first job
		If GUICtrlRead($Checkbox_ask) = $GUI_CHECKED Then
			$ask = 1
		Else
			$ask = 4
		EndIf
		IniWrite($inifle, "First Job Process", "ask", $ask)
	Case $msg = $Combo_wait
		; Minutes to wait before processing current selection
		$source = GUICtrlRead($Input_srce)
		If $source <> "" Then
			If $jobs = "||" Then
				GUICtrlSetData($Combo_wait, "0")
				MsgBox(262192, "Job Error", "No jobs have been set.", 0, $TCTimer)
			Else
				$waiting = GUICtrlRead($Combo_wait)
				$job = StringSplit($jobs, "|")
				If $job[0] > 2 Then
					For $j = 3 To $job[0]
						If $source = IniRead($projfle, $job[$j], "source", "") Then
							IniWrite($projfle, $job[$j], "wait", $waiting)
							$bytes = IniRead($projfle, $job[$j], "size", "")
							If $waiting < 1 And $j > 3 Then
								$bytes = $bytes + IniRead($projfle, $job[$j - 1], "subtotal", "")
							EndIf
							IniWrite($projfle, $job[$j], "subtotal", $bytes)
							If $total = "sub" Then
								SourceGetBytes()
								$subtot = $bytes
								GUICtrlSetData($Label_sum, $subtot)
							EndIf
							$job = $job[$j]
							ExitLoop
						EndIf
						If $j = $job[0] Then
							GUICtrlSetData($Combo_wait, "0")
							$job = GUICtrlRead($Combo_job)
							MsgBox(262192, "Job Error", "A job name has not been set for source.", 0, $TCTimer)
						EndIf
					Next
				Else
					$job = ""
				EndIf
			EndIf
		Else
			GUICtrlSetData($Combo_wait, "0")
			MsgBox(262192, "Source Error", "No path has been set.", 0, $TCTimer)
		EndIf
	Case $msg = $Combo_ord
		; Order
		$n = GUICtrlRead($Combo_ord)
		If $n <> "" Then
			$job = IniRead($projfle, "Jobs", $n, "")
			If $job <> "" Then
				GUICtrlSetData($Combo_job, $job)
				ShowDetailsForJob()
;~ 				$source = IniRead($projfle, $job, "source", "")
;~ 				GUICtrlSetData($Input_srce, $source)
;~ 				$dest = IniRead($projfle, $job, "destination", "")
;~ 				GUICtrlSetData($Input_dest, $dest)
;~ 				$copy = IniRead($projfle, $job, "process", "")
;~ 				GUICtrlSetData($Combo_copy, $copy)
;~ 				GUICtrlSetData($Combo_job, "", "")
;~ 				GUICtrlSetData($Combo_job, $jobs, $job)
;~ 				$waiting = IniRead($projfle, $job, "wait", "0")
;~ 				GUICtrlSetData($Combo_wait, $waiting)
			EndIf
		EndIf
	Case $msg = $Combo_job
		; Job Name
		$job = GUICtrlRead($Combo_job)
		If $job <> "" Then
			ShowDetailsForJob()
		EndIf
		If $tot > 0 Then
			If $combfle = "" Then
				GUICtrlSetData($Group_pths, "Job Paths  (" & $tot & ")")
			Else
				GUICtrlSetData($Group_pths, "Job Paths  (" & $tot & ") (" & $pths & ")")
			EndIf
		Else
			GUICtrlSetData($Group_pths, "Job Paths")
		EndIf
	Case $msg = $Combo_how
		; Add to List choice
		$how = GUICtrlRead($Combo_how)
		If $combine = 1 Then
			If $how = "View List" Then
				If $addconc = 1 Then
					$how = "Add To List"
				Else
					$how = ""
				EndIf
				ViewCombineList()
			Else
				If $how = "Add To List" Then
					$addconc = 1
				ElseIf $how = "New List" Then
					$newlist = 1
					$addconc = 1
				Else
					$addconc = 4
				EndIf
				IniWrite($inifle, "Add To Combine List", "concenate", $addconc)
			EndIf
		Else
			If $how = "View List" Then
				If $addsolo = 1 Then
					$how = "Add To List"
				Else
					$how = ""
				EndIf
				ViewCombineList()
			Else
				If $how = "Add To List" Then
					$addsolo = 1
				ElseIf $how = "New List" Then
					$newlist = 1
					$addsolo = 1
				Else
					$addsolo = 4
				EndIf
				IniWrite($inifle, "Add To Combine List", "individual", $addsolo)
			EndIf
		EndIf
	Case $msg = $Combo_fav
		; Favorite Destinations
		$fav = GUICtrlRead($Combo_fav)
		If $fav <> "" Then
			$fv = StringMid($favs, 3)
			$fv = StringSplit($fv, "|")
			For $n = 1 To $fv[0]
				If $fav = $fv[$n] Then
					If GUICtrlRead($Input_dest) = "" Then
						$ans = 1
					Else
						$ans = MsgBox(262193, "Destination Query", _
							"Do you want to replace the currently listed destination" & @LF & _
							"path with the currently selected favorite?", 0, $TCTimer)
					EndIf
					If $ans = 1 Then
						$dest = IniRead($inifle, "Favorites", $n, "")
						GUICtrlSetData($Input_dest, $dest)
						If FileExists($dest) Then
							IniWrite($inifle, "Destination Path", "last", $dest)
							GUICtrlSetState($Button_set, $GUI_ENABLE)
							GUICtrlSetState($Button_min, $GUI_ENABLE)
						Else
							GUICtrlSetState($Button_set, $GUI_DISABLE)
							GUICtrlSetState($Button_min, $GUI_DISABLE)
							MsgBox(262192, "Destination Error", "Path does not exist!", 0, $TCTimer)
						EndIf
					EndIf
					ExitLoop
				EndIf
			Next
		EndIf
	Case $msg = $Combo_copy
		; Favorite Destinations
		$copy = GUICtrlRead($Combo_copy)
	Case $msg = $Label_total
		; Show Sum Total or Subtotal
		;MsgBox(262192, "Error Check", "Some Text", 0)
		If $total = "sum" Then
			$total = "sub"
			GUICtrlSetBkColor($Label_total, 0xF00000)
			If $job <> "" Then
				$subtot = IniRead($projfle, $job, "subtotal", "")
				$bytes = $subtot
				SourceGetBytes()
				$subtot = $bytes
				GUICtrlSetData($Label_sum, $subtot)
			EndIf
		ElseIf $total = "sub" Then
			$total = "sum"
			GUICtrlSetBkColor($Label_total, 0x000000)
			If $job <> "" Then
				$sum = IniRead($projfle, "Total Size", "sum", "")
				$bytes = $sum
				SourceGetBytes()
				$sum = $bytes
				GUICtrlSetData($Label_sum, $sum)
			EndIf
		EndIf
	Case $msg = $Item_remove
		; Remove All Thumbs.db files
		If $remove = 4 Then
			$remove = 1
			GUICtrlSetData($Button_start, "Remove")
			GUICtrlSetTip($Button_start, "Remove All Thumbs.db files!")
			If $dest <> "" Then
				GUICtrlSetState($Button_set, $GUI_DISABLE)
				GUICtrlSetState($Button_min, $GUI_DISABLE)
			EndIf
			If $use = 1 Then
				GUICtrlSetState($Input_delay, $GUI_DISABLE)
				GUICtrlSetState($Updown_delay, $GUI_DISABLE)
				GUICtrlSetState($Button_adv, $GUI_DISABLE)
			EndIf
			GUICtrlSetState($Checkbox_up, $GUI_DISABLE)
			GUICtrlSetState($Combo_wait, $GUI_DISABLE)
			GUICtrlSetState($Button_srce, $GUI_DISABLE)
			GUICtrlSetState($Button_last, $GUI_DISABLE)
			GUICtrlSetState($Button_change, $GUI_DISABLE)
			GUICtrlSetState($Button_process, $GUI_DISABLE)
			GUICtrlSetState($Input_dest, $GUI_DISABLE)
			GUICtrlSetState($Combo_copy, $GUI_DISABLE)
			GUICtrlSetState($Checkbox_ask, $GUI_DISABLE)
			GUICtrlSetState($Button_sav, $GUI_DISABLE)
			GUICtrlSetState($Button_dest, $GUI_DISABLE)
			GUICtrlSetState($Combo_job, $GUI_DISABLE)
			GUICtrlSetState($Button_del, $GUI_DISABLE)
			GUICtrlSetState($Combo_ord, $GUI_DISABLE)
			GUICtrlSetState($Input_ord, $GUI_DISABLE)
			GUICtrlSetState($Updown_ord, $GUI_DISABLE)
			GUICtrlSetState($Checkbox_shut, $GUI_DISABLE)
			GUICtrlSetState($Combo_fav, $GUI_DISABLE)
			GUICtrlSetState($Button_add, $GUI_DISABLE)
			GUICtrlSetState($Checkbox_use, $GUI_DISABLE)
			GUICtrlSetState($Checkbox_thumb, $GUI_DISABLE)
		Else
			$remove = 4
			GUICtrlSetData($Button_start, "START")
			GUICtrlSetTip($Button_start, "Start Jobs!")
			If $dest <> "" Then
				GUICtrlSetState($Button_set, $GUI_ENABLE)
				GUICtrlSetState($Button_min, $GUI_ENABLE)
			EndIf
			If $use = 1 Then
				GUICtrlSetState($Input_delay, $GUI_ENABLE)
				GUICtrlSetState($Updown_delay, $GUI_ENABLE)
				GUICtrlSetState($Button_adv, $GUI_ENABLE)
			EndIf
			GUICtrlSetState($Checkbox_up, $GUI_ENABLE)
			GUICtrlSetState($Combo_wait, $GUI_ENABLE)
			GUICtrlSetState($Button_srce, $GUI_ENABLE)
			GUICtrlSetState($Button_last, $GUI_ENABLE)
			GUICtrlSetState($Button_change, $GUI_ENABLE)
			GUICtrlSetState($Button_process, $GUI_ENABLE)
			GUICtrlSetState($Input_dest, $GUI_ENABLE)
			GUICtrlSetState($Combo_copy, $GUI_ENABLE)
			GUICtrlSetState($Checkbox_ask, $GUI_ENABLE)
			GUICtrlSetState($Button_sav, $GUI_ENABLE)
			GUICtrlSetState($Button_dest, $GUI_ENABLE)
			GUICtrlSetState($Combo_job, $GUI_ENABLE)
			GUICtrlSetState($Button_del, $GUI_ENABLE)
			GUICtrlSetState($Combo_ord, $GUI_ENABLE)
			GUICtrlSetState($Input_ord, $GUI_ENABLE)
			GUICtrlSetState($Updown_ord, $GUI_ENABLE)
			GUICtrlSetState($Checkbox_shut, $GUI_ENABLE)
			GUICtrlSetState($Combo_fav, $GUI_ENABLE)
			GUICtrlSetState($Button_add, $GUI_ENABLE)
			GUICtrlSetState($Checkbox_use, $GUI_ENABLE)
			GUICtrlSetState($Checkbox_thumb, $GUI_ENABLE)
		EndIf
		GUICtrlSetState($Item_remove, $remove)
	Case $msg = $Updown_ord
		; Set Order
		$curr = GUICtrlRead($Combo_ord)
		If $curr <> "" Then
			$job = GUICtrlRead($Combo_job)
			If $job <> "" Then
				$tot = IniRead($projfle, "Jobs", "total", $tot)
				$change = GUICtrlRead($Input_ord)
				If $updwn > $change Then
					If $curr > 1 Then
						$new = $curr - 1
					Else
						$new = $curr
					EndIf
					$loc = "less"
				ElseIf $updwn < $change Then
					If $curr = $tot Then
						$new = $curr
					Else
						$new = $curr + 1
					EndIf
					$loc = "more"
				EndIf
				;MsgBox(262192, "$curr $change $updwn $new", $curr & " : " & $change & " : " & $updwn & " : " & $new, 0)
				If $curr <> $new Then
					GUICtrlSetData($Combo_ord, $new)
					$tmp = IniRead($projfle, "Jobs", $curr, "")
					$c = IniRead($projfle, "Jobs", $new, "")
					IniWrite($projfle, "Jobs", $curr, $c)
					IniWrite($projfle, $c, "order", $curr)
					IniWrite($projfle, "Jobs", $new, $tmp)
					IniWrite($projfle, $tmp, "order", $new)
					$names = StringSplit($jobs, "|")
					If $loc = "less" Then
						_ArraySwap($names[$curr + 2], $names[$curr + 1])
					ElseIf $loc = "more" Then
						_ArraySwap($names[$curr + 3], $names[$curr + 2])
					EndIf
					$jobs = _ArrayToString($names, "|", 1)
					IniWrite($projfle, "Jobs", "names", $jobs)
					GUICtrlSetData($Combo_job, "", "")
					GUICtrlSetData($Combo_job, $jobs, $job)
				EndIf
				$updwn = 100
				GUICtrlSetData($Input_ord, $updwn)
			EndIf
		EndIf
	Case $msg = $Updown_delay
		; Set Delay
		$delay = GUICtrlRead($Input_delay)
		IniWrite($inifle, "Delay", "mins", $delay)
	Case Else
		;;;
	EndSelect
WEnd

Exit

Func AdvancedDelayOpts()
	Local $Button_i2, $Button_x2, $Checkbox_dub, $Checkbox_ena, $Checkbox_hlf, $Checkbox_non
	Local $Group_abs, $Group_bes, $Group_rest, $Input_abs, $Input_bes, $Input_del, $Input_mins
	Local $Input_pse, $Input_rest, $Label_bes, $Label_del, $Label_jobs, $Label_meg, $Label_mins
	Local $Label_pse, $Label_rest, $Updown_abs, $Updown_bes, $Updown_del, $Updown_mins, $Updown_pse
	Local $Updown_rest
	;
	$AdvancedDelay = GuiCreate("Advanced Delay Options", 335, 200, -1, -1, $WS_OVERLAPPED + $WS_CAPTION _
							+ $WS_SYSMENU + $WS_VISIBLE + $WS_CLIPSIBLINGS, $WS_EX_TOPMOST, $TCTimer)
	;
	$Group_abs = GuiCtrlCreateGroup("Above Size && Delay", 10, 10, 189, 55)
	$Input_abs = GuiCtrlCreateInput("", 20, 30, 65, 20, $ES_NUMBER)
	GUICtrlSetLimit($Input_abs, 6)
	$Updown_abs = GUICtrlCreateUpdown($Input_abs)
	GUICtrlSetTip($Updown_abs, "Size adjust!")
	$Label_meg = GUICtrlCreateLabel("Mb's", 90, 30, 28, 20, $SS_CENTERIMAGE)
	;;;;;;
	$Input_del = GuiCtrlCreateInput("", 125, 30, 35, 20, $ES_NUMBER)
	$Updown_del = GUICtrlCreateUpdown($Input_del)
	GUICtrlSetLimit($Updown_del, 30, 0)
	GUICtrlSetTip($Updown_del, "Delay adjust!")
	$Label_del = GUICtrlCreateLabel("mins", 165, 30, 28, 20, $SS_CENTERIMAGE)
	;
	$Group_bes = GuiCtrlCreateGroup("Below Size && Delay", 10, 75, 189, 55)
	$Input_bes = GuiCtrlCreateInput("", 20, 95, 65, 20, $ES_NUMBER)
	GUICtrlSetLimit($Input_bes, 6)
	$Updown_bes = GUICtrlCreateUpdown($Input_bes)
	GUICtrlSetTip($Updown_bes, "Size adjust!")
	$Label_bes = GUICtrlCreateLabel("Mb's", 90, 95, 28, 20, $SS_CENTERIMAGE)
	;;;;;;
	$Input_pse = GuiCtrlCreateInput("", 125, 95, 35, 20, $ES_NUMBER)
	$Updown_pse = GUICtrlCreateUpdown($Input_pse)
	GUICtrlSetLimit($Updown_pse, 30, 0)
	GUICtrlSetTip($Updown_pse, "Delay adjust!")
	$Label_pse = GUICtrlCreateLabel("mins", 165, 95, 28, 20, $SS_CENTERIMAGE)
	;
	$Checkbox_ena = GuiCtrlCreateCheckbox("Enable", 210, 20, 55, 20)
	GUICtrlSetTip($Checkbox_ena, "Enable Advanced Delay!")
	;
	$Checkbox_dub = GuiCtrlCreateCheckbox("Double", 210, 43, 55, 20)
	GUICtrlSetTip($Checkbox_dub, "Use Double the Delay!")
	;
	$Checkbox_non = GuiCtrlCreateCheckbox("None", 210, 85, 55, 20)
	GUICtrlSetTip($Checkbox_non, "No Below Delay!")
	;
	$Checkbox_hlf = GuiCtrlCreateCheckbox("Half Of", 210, 108, 55, 20)
	GUICtrlSetTip($Checkbox_hlf, "No Delay Half Below!")
	;
	$Button_i2 = GuiCtrlCreateButton("Info", 275, 15, 50, 50, $BS_ICON)
	GUICtrlSetTip($Button_i2, "Advanced Information!")
	$Button_x2 = GuiCtrlCreateButton("EXIT", 275, 80, 50, 50, $BS_ICON)
	GUICtrlSetTip($Button_x2, "Quit or Close window!")
	;
	$Group_rest = GuiCtrlCreateGroup("Rest Periods", 10, 140, 315, 50)
	$Checkbox_rest = GuiCtrlCreateCheckbox("Enable", 20, 160, 55, 20)
	GUICtrlSetTip($Checkbox_rest, "Enable Rest Periods!")
	$Label_rest = GUICtrlCreateLabel("Resting every", 85, 160, 68, 20, $SS_CENTERIMAGE)
	$Input_rest = GuiCtrlCreateInput("", 155, 160, 38, 20, $ES_NUMBER)
	$Updown_rest = GUICtrlCreateUpdown($Input_rest)
	GUICtrlSetLimit($Updown_rest, 99, 1)
	GUICtrlSetTip($Updown_rest, "Adjust number of jobs value!")
	$Label_jobs = GUICtrlCreateLabel("jobs for", 193, 160, 42, 20, $SS_CENTER + $SS_CENTERIMAGE)
	$Input_mins = GuiCtrlCreateInput("", 235, 160, 38, 20, $ES_NUMBER)
	$Updown_mins = GUICtrlCreateUpdown($Input_mins)
	GUICtrlSetLimit($Updown_mins, 30, 1)
	GUICtrlSetTip($Updown_mins, "Adjust number of minutes value!")
	$Label_mins = GUICtrlCreateLabel("minutes", 273, 160, 47, 20, $SS_CENTER + $SS_CENTERIMAGE)
	;
	; SETTINGS
	GUICtrlSetImage($Button_i2, $user, $icoI, 1)
	GUICtrlSetImage($Button_x2, $icofle, $icoX, 1)
	;
	GUICtrlSetData($Input_del, $idle)
	;
	GUICtrlSetData($Input_abs, $above)
	;
	GUICtrlSetData($Input_pse, $pause)
	;
	GUICtrlSetData($Input_bes, $below)
	;
	GUICtrlSetState($Checkbox_ena, $advance)
	;
	GUICtrlSetState($Checkbox_dub, $double)
	;
	GUICtrlSetState($Checkbox_non, $none)
	;
	GUICtrlSetState($Checkbox_hlf, $half)
	;
	If $double = 1 Then
		GUICtrlSetState($Input_del, $GUI_DISABLE)
		GUICtrlSetState($Updown_del, $GUI_DISABLE)
	EndIf
	;
	If $none = 1 Then
		GUICtrlSetState($Input_pse, $GUI_DISABLE)
		GUICtrlSetState($Updown_pse, $GUI_DISABLE)
		GUICtrlSetState($Checkbox_hlf, $GUI_DISABLE)
	EndIf
	;
	GUICtrlSetState($Checkbox_rest, $rest)
	If $rest = 4 Then
		GUICtrlSetState($Input_rest, $GUI_DISABLE)
		GUICtrlSetState($Updown_rest, $GUI_DISABLE)
		GUICtrlSetState($Input_mins, $GUI_DISABLE)
		GUICtrlSetState($Updown_mins, $GUI_DISABLE)
	EndIf
	GUICtrlSetData($Input_rest, $tasks)
	GUICtrlSetData($Input_mins, $time)
	
	
	GuiSetState()
	While 1
		$msg = GuiGetMsg()
		Select
		Case $msg = $GUI_EVENT_CLOSE Or $msg = $Button_x2
			; Quit or Close window
			$idle = GUICtrlRead($Input_del)
			IniWrite($inifle, "Delay", "idle", $idle)
			$above = GUICtrlRead($Input_abs)
			IniWrite($inifle, "Delay", "above", $above)
			;
			$pause = GUICtrlRead($Input_pse)
			IniWrite($inifle, "Delay", "pause", $pause)
			$below = GUICtrlRead($Input_bes)
			IniWrite($inifle, "Delay", "before", $below)
			;
			$tasks = GUICtrlRead($Input_rest)
			IniWrite($inifle, "Rest Periods", "jobs", $tasks)
			$time = GUICtrlRead($Input_mins)
			IniWrite($inifle, "Rest Periods", "minutes", $time)
			;
			GUIDelete($AdvancedDelay)
			ExitLoop
		Case $msg = $Button_i2
			; Advanced Information
			$ans = MsgBox(262465, "Program Information", _
				"These settings allow you to override the standard" & @LF & _
				"delay setting, based on their criteria." & @LF & @LF & _
				"14336 Mb's is equivalent to 14 Gb." & @LF & _
				"4096 Mb's is equivalent to 4 Gb." & @LF & _
				"(1024 Mb's = 1 Gb)" & @LF & @LF & _
				"When 'Double' is enabled, then that is double the" & @LF & _
				"standard delay value, and any advanced value is" & @LF & _
				"ignored." & @LF & @LF & _
				"A rule of thumb could be -" & @LF & _
				"3 mins (standard value)" & @LF & _
				"6 mins (advanced value when doubled)" & @LF & _
				"with all Jobs (files or folders) below 14 Gb, having" & @LF & _
				"a 3 minute wait between jobs, while all those over" & @LF & _
				"14 Gb, having the 6 minute wait." & @LF & @LF & _
				"When 'None' is enabled, then no delay will occur" & @LF & _
				"for jobs less than the specified 'Below Size'." & @LF & @LF & _
				"When 'Half' is enabled, then no delay will occur" & @LF & _
				"for jobs less than half the specified 'Below Size'." & @LF & _
				"Using 'Half' essentially allows four delay values." & @LF & @LF & _
				"Advanced values are only used if option enabled." & @LF & @LF & _
				"Click OK to see last 'Rest Period Results'.", 0, $AdvancedDelay)
			If $ans = 1 Then
				Local $duration, $started, $stopped, $err = ""
				$started = IniRead($inifle, "Rest Period", "started", "")
				If $started <> "" Then
					$stopped = IniRead($inifle, "Rest Period", "stopped", "")
					If $stopped <> "" Then
						$duration = _DateDiff("n", $started, $stopped)
						;$err = @error
						MsgBox(262208, "Rest Period Results", _
							"Started = " & $started & @LF & _
							"Stopped = " & $stopped & @LF & @LF & _
							"Duration = " & $duration & " minutes." & $err, 0, $AdvancedDelay)
					Else
						SplashTextOn("", "No Stop Data!", 180, 80, -1, -1, 33)
						Sleep(1000)
						SplashOff()
					EndIf
				Else
					SplashTextOn("", "No Start Data!", 180, 80, -1, -1, 33)
					Sleep(1000)
					SplashOff()
				EndIf
			EndIf
		Case $msg = $Checkbox_rest
			; Enable Rest Periods
			If GUICtrlRead($Checkbox_rest) = $GUI_CHECKED Then
				$rest = 1
				GUICtrlSetState($Input_rest, $GUI_ENABLE)
				GUICtrlSetState($Updown_rest, $GUI_ENABLE)
				GUICtrlSetState($Input_mins, $GUI_ENABLE)
				GUICtrlSetState($Updown_mins, $GUI_ENABLE)
			Else
				$rest = 4
				GUICtrlSetState($Input_rest, $GUI_DISABLE)
				GUICtrlSetState($Updown_rest, $GUI_DISABLE)
				GUICtrlSetState($Input_mins, $GUI_DISABLE)
				GUICtrlSetState($Updown_mins, $GUI_DISABLE)
			EndIf
			IniWrite($inifle, "Rest Periods", "enable", $rest)
		Case $msg = $Checkbox_non
			; No Below Delay
			If GUICtrlRead($Checkbox_non) = $GUI_CHECKED Then
				$none = 1
				GUICtrlSetState($Input_pse, $GUI_DISABLE)
				GUICtrlSetState($Updown_pse, $GUI_DISABLE)
				GUICtrlSetState($Checkbox_hlf, $GUI_DISABLE)
			Else
				$none = 4
				GUICtrlSetState($Input_pse, $GUI_ENABLE)
				GUICtrlSetState($Updown_pse, $GUI_ENABLE)
				GUICtrlSetState($Checkbox_hlf, $GUI_ENABLE)
			EndIf
			IniWrite($inifle, "Delay", "none", $none)
		Case $msg = $Checkbox_hlf
			; No Delay Half Below
			If GUICtrlRead($Checkbox_hlf) = $GUI_CHECKED Then
				$half = 1
			Else
				$half = 4
			EndIf
			IniWrite($inifle, "Delay", "half", $half)
		Case $msg = $Checkbox_ena
			; Enable Advanced Delay
			If GUICtrlRead($Checkbox_ena) = $GUI_CHECKED Then
				$advance = 1
			Else
				$advance = 4
			EndIf
			IniWrite($inifle, "Delay", "advanced", $advance)
			GUISwitch($TCTimer)
			If $advance = 1 Then
				GUICtrlSetState($Input_delay, $GUI_DISABLE)
				GUICtrlSetState($Updown_delay, $GUI_DISABLE)
			Else
				GUICtrlSetState($Input_delay, $GUI_ENABLE)
				GUICtrlSetState($Updown_delay, $GUI_ENABLE)
			EndIf
			GUISwitch($AdvancedDelay)
		Case $msg = $Checkbox_dub
			; Use Double the Delay
			If GUICtrlRead($Checkbox_dub) = $GUI_CHECKED Then
				$double = 1
				GUICtrlSetState($Input_del, $GUI_DISABLE)
				GUICtrlSetState($Updown_del, $GUI_DISABLE)
			Else
				$double = 4
				GUICtrlSetState($Input_del, $GUI_ENABLE)
				GUICtrlSetState($Updown_del, $GUI_ENABLE)
			EndIf
			IniWrite($inifle, "Delay", "double", $double)
		Case $msg = $Updown_rest
			; Rest Periods - Adjust number of jobs value
			$tasks = GUICtrlRead($Input_rest)
			IniWrite($inifle, "Rest Periods", "jobs", $tasks)
		Case $msg = $Updown_pse
			; Delay adjust - Below
			$pause = GUICtrlRead($Input_pse)
			IniWrite($inifle, "Delay", "pause", $pause)
		Case $msg = $Updown_mins
			; Rest Periods - Adjust number of minutes value
			$time = GUICtrlRead($Input_mins)
			IniWrite($inifle, "Rest Periods", "minutes", $time)
		Case $msg = $Updown_del
			; Delay adjust - Above
			$idle = GUICtrlRead($Input_del)
			IniWrite($inifle, "Delay", "idle", $idle)
		Case $msg = $Updown_bes
			; Size adjust - Below
			$below = GUICtrlRead($Input_bes)
			If $below < 0 Then
				$below = 0
				GUICtrlSetData($Input_bes, $below)
			EndIf
			IniWrite($inifle, "Delay", "before", $below)
		Case $msg = $Updown_abs
			; Size adjust - Above
			$above = GUICtrlRead($Input_abs)
			If $above < 0 Then
				$above = 0
				GUICtrlSetData($Input_abs, $above)
			EndIf
			IniWrite($inifle, "Delay", "above", $above)
		Case Else
			;;;
		EndSelect
	WEnd
EndFunc ;=> AdvancedDelayOpts (GUI)

Func DropboxGUI()
	Local $List_drop, $attribs, $close, $drive, $Dropbox, $right
	$right = @DesktopWidth - 87
	$left = IniRead($inifle, "Dropbox Window", "left", $right)
	$top = IniRead($inifle, "Dropbox Window", "top", 27)
	$Dropbox = GuiCreate("Dropbox", 82, 60, $left, $top, $WS_OVERLAPPED + $WS_CAPTION + $WS_SYSMENU + $WS_VISIBLE _
							+ $WS_CLIPSIBLINGS, $WS_EX_ACCEPTFILES + $WS_EX_TOPMOST + $WS_EX_TOOLWINDOW, $TCTimer)
	;
	$List_drop = GUICtrlCreateList("", 0, 0, 80, 68, $WS_BORDER + $LBS_NOSEL) ; + $WS_VSCROLL
	GUICtrlSetState($List_drop, $GUI_DROPACCEPTED)
	GUICtrlSetFont($List_drop, 8, 400)
	GUICtrlSetTip($List_drop, "Drop a Folder or Drive Here!")
	;
	; SETTINGS
	GUICtrlSetData($List_drop, '   Drop a new')
	GUICtrlSetData($List_drop, '   Destination')
	GUICtrlSetData($List_drop, 'Drive or Folder')
	GUICtrlSetData($List_drop, '       HERE')
	;
	$close = ""

	GuiSetState()
	While 1
		$msg = GuiGetMsg()
		Select
		Case $msg = $GUI_EVENT_CLOSE Or $close = 1
			; Close the Dropbox
			$winpos = WinGetPos($Dropbox, "")
			$left = $winpos[0]
			If $left < 0 Then
				$left = 2
			ElseIf $left > @DesktopWidth - $winpos[2] Then
				$left = @DesktopWidth - $winpos[2]
			EndIf
			IniWrite($inifle, "Dropbox Window", "left", $left)
			$top = $winpos[1]
			If $top < 0 Then
				$top = 2
			ElseIf $top > @DesktopHeight - $winpos[3] Then
				$top = @DesktopHeight - $winpos[3]
			EndIf
			IniWrite($inifle, "Dropbox Window", "top", $top)
			;
			GUIDelete($Dropbox)
			ExitLoop
		Case $msg = $GUI_EVENT_DROPPED
			; Folder added as new destination by drag and drop
			If @GUI_DragId = -1 Then
				If FileExists(@GUI_DragFile) Then
					$attribs = FileGetAttrib(@GUI_DragFile)
					If StringInStr($attribs, "D") > 0 Then
						GUICtrlSetState($List_drop, $GUI_DISABLE)
						$dest = @GUI_DragFile
						$drive = ""
						If StringLen($dest) = 3 Then
							$ans = MsgBox(262179, "Change Destination For All", _
								"You have dropped a drive not folder." & @LF & @LF & _
								"What portion of the destination path" & @LF & _
								"would you like to change?" & @LF & @LF & _
								"YES = Replace the drive only." & @LF & _
								"NO = Replace the full path." & @LF & _
								"CANCEL = Abort.", 0, $Dropbox)
							If $ans = 6 Then
								$drive = $dest
							ElseIf $ans = 7 Then
							ElseIf $ans = 2 Then
								$dest = ""
							EndIf
						EndIf
						If $dest <> "" Then
							GUISwitch($TCTimer)
							If $drive <> "" Then
								$dest = GUICtrlRead($Input_dest)
								$dest = $drive & StringTrimLeft($dest, 3)
							EndIf
							GUICtrlSetData($Input_dest, $dest)
							GUISwitch($Dropbox)
							$tot = IniRead($projfle, "Jobs", "total", "")
							If $tot <> "" Then
								For $j = 1 To $tot
									$job = IniRead($projfle, "Jobs", $j, "")
									If $job <> "" Then
										If $drive <> "" Then
											$dest = IniRead($projfle, $job, "destination", "")
											$dest = $drive & StringTrimLeft($dest, 3)
										EndIf
										IniWrite($projfle, $job, "destination", $dest)
									EndIf
								Next
								$close = 1
							Else
								MsgBox(262192, "Change Error", "No jobs are listed.", 0, $Dropbox)
							EndIf
						EndIf
						GUICtrlSetState($List_drop, $GUI_ENABLE)
					Else
						MsgBox(262192, "Drag Error", "Needs to be a folder or drive not file.", 0, $Dropbox)
					EndIf
				Else
					MsgBox(262192, "Drag Error", "Drag & Drop path doesn't exist.", 0, $Dropbox)
				EndIf
			Else
				MsgBox(262192, "Drag Error", "Drag & Drop failed.", 0, $Dropbox)
			EndIf
		Case Else
			;;;
		EndSelect
	WEnd
EndFunc ;=> DropboxGUI


Func AddSourceToCombineList()
	If $projfle = "" Then GetSetProjectFile(1)
	If ($p = 2 And $combfle = "") Or $combfle = "" Then
		$n = 1
		$combfle = @ScriptDir & "\Combine List _"
		While FileExists($combfle & $n & ".txt")
			$n = $n + 1
		WEnd
		$combfle = $combfle & $n & ".txt"
		$combsze = 0
	EndIf
	FileWriteLine($combfle, $source)
	If FileExists($source) Then
		SourceGetSize(0)
		$combsze = $combsze + $bytes
	EndIf
	GetCombineFileTruePathsCount()
	If $p = $paths[0] Then
		$source = $combfle
		GUICtrlSetData($Input_srce, $source)
		If $job = "" Then
			$job = StringSplit($source, "\")
			$job = $job[$job[0]]
			$job = StringTrimRight($job, 4)
			IniWrite($projfle, $job, "source", $source)
			GUICtrlSetData($Combo_ord, "", "")
			$jobs = $jobs & $job & "|"
			IniWrite($projfle, "Jobs", "names", $jobs)
			$tot = IniRead($projfle, "Jobs", "total", $tot)
			$tot = $tot + 1
			IniWrite($projfle, $job, "order", $tot)
			IniWrite($projfle, "Jobs", "total", $tot)
			IniWrite($projfle, "Jobs", $tot, $job)
			$nums = $nums & "|" & $tot
			GUICtrlSetData($Combo_ord, $nums, $tot)
			GUICtrlSetData($Group_pths, "Job Paths  (" & $tot & ") (" & $pths & ")")
			GUICtrlSetData($Combo_job, "", "")
			GUICtrlSetData($Combo_job, $jobs, $job)
			GUICtrlSetState($Button_set, $GUI_DISABLE)
			GUICtrlSetState($Button_min, $GUI_DISABLE)
			$dest = GUICtrlRead($Input_dest)
			If $dest <> "" Then
				UpdateDestinationValues()
			EndIf
		Else
			GUICtrlSetData($Group_pths, "Job Paths  (" & $tot & ") (" & $pths & ")")
		EndIf
		$bytes = $combsze
		IniWrite($projfle, $job, "size", $bytes)
		SourceGetBytes()
		GUICtrlSetData($Label_size, $bytes)
		GetTotalSize()
	EndIf
EndFunc ;=> AddSourceToCombineList

Func ClearQuery()
	$source = ""
	$job = ""
	$ans = MsgBox(262435, "Clear Query", _
		"Do you want to clear the Source and" & @LF & _
		"or Destination fields?" & @LF & @LF & _
		"YES = Clear Both." & @LF & _
		"NO = Clear Source only (default)." & @LF & @LF & _
		"CANCEL = Skip clearing any.", 0, $TCTimer)
	If $ans = 6 Then
		GUICtrlSetData($Input_srce, "")
		GUICtrlSetData($Input_dest, "")
	ElseIf $ans = 7 Then
		GUICtrlSetData($Input_srce, "")
	EndIf
EndFunc ;=> ClearQuery
       
Func EnableDisableControls($state)
	If $dest <> "" Then GUICtrlSetState($Button_min, $state)
	;
	GUICtrlSetState($Input_srce, $state)
	GUICtrlSetState($Checkbox_up, $state)
	If $dest <> "" Then GUICtrlSetState($Button_set, $state)
	GUICtrlSetState($Button_sfle, $state)
	GUICtrlSetState($Button_sfld, $state)
	GUICtrlSetState($Combo_wait, $state)
	;
	GUICtrlSetState($Button_srce, $state)
	GUICtrlSetState($Button_last, $state)
	GUICtrlSetState($Button_change, $state)
	GUICtrlSetState($Button_process, $state)
	GUICtrlSetState($Input_dest, $state)
	GUICtrlSetState($Combo_copy, $state)
	GUICtrlSetState($Checkbox_ask, $state)
	GUICtrlSetState($Button_sav, $state)
	GUICtrlSetState($Button_dest, $state)
	;
	GUICtrlSetState($Button_del, $state)
	GUICtrlSetState($Combo_ord, $state)
	GUICtrlSetState($Updown_ord, $state)
	If $use = 1 Then
		GUICtrlSetState($Button_adv, $state)
		GUICtrlSetState($Input_delay, $state)
		GUICtrlSetState($Updown_delay, $state)
	EndIf
	GUICtrlSetState($Button_start, $state)
	GUICtrlSetState($Checkbox_shut, $state)
	;
	GUICtrlSetState($Combo_fav, $state)
	GUICtrlSetState($Button_add, $state)
	GUICtrlSetState($Checkbox_use, $state)
	GUICtrlSetState($Checkbox_thumb, $state)
	GUICtrlSetState($Button_i, $state)
	GUICtrlSetState($Button_x, $state)
EndFunc ;=> EnableDisableControls

Func GetCombineFileTruePathsCount()
	$pths = 0
	$res = _FileReadToArray($combfle, $array)
	If $res = 1 Then
		For $a = 1 To $array[0]
			If $array[$a] <> "" Then $pths = $pths + 1
		Next
	EndIf
EndFunc ;=> GetCombineFileTruePathsCount

Func GetFolderList($srcpth)
    Local $sFolder, $schfld, $schpth
	;
    If StringRight($srcpth, 1) <> "\" Then $srcpth &= "\"
    ;
    Local $dSearch = FileFindFirstFile($srcpth & "*")
    ;
    If $dSearch = -1 Then Return
	;
	;If FileExists($srcpth & "Thumbs.db") Then FileDelete($srcpth & "Thumbs.db")
	;
	While 1
		$sFolder = FileFindNextFile($dSearch)
		If @error Then ExitLoop
		;
		If StringRight($sline, 1) = "0" Then
			If _IsPressed("23", $dll) Then
				;$exit = 1
				ExitLoop
			EndIf
		EndIf
		$sline = $sline + 1
		;
		$schpth = $srcpth & $sFolder
		If StringInStr(FileGetAttrib($schpth), "D") > 0 Then
			;MsgBox(262160, "$schpth", $schpth)
			$lines = $lines + 1
			;If $resw = 0 Then MsgBox(262160, "Failed", $schpth)
			$schfld = $srcpth & $sFolder
			GetFolderList($schfld)
		Else
			If $sFolder = "Thumbs.db" Then
				FileDelete($schpth)
				$thumbs = $thumbs + 1
			EndIf
		EndIf
	WEnd
	;
	FileClose($dSearch)
EndFunc ;=> GetFolderList

Func GetSetProjectFile($val)
	$project = _Now()
	$project = StringReplace($project, "/", "-")
	$project = StringReplace($project, ":", "_")
	;MsgBox(262192, "$project", $project, 0)
	$projfle = $projects & "\" & $project & ".ini"
	If $val = 1 Then IniWrite($inifle, "Last Project", "file", $projfle)
EndFunc ;=> GetSetProjectFile

Func GetTotalSize()
	Local $a, $name, $names
	$sum = 0
	$subtot = 0
	$jobs = IniRead($projfle, "Jobs", "names", "")
	$names = StringSplit($jobs, "|")
	For $a = 1 To $names[0]
		$name = $names[$a]
		If $name <> "" Then
			$bytes = IniRead($projfle, $name, "size", "")
			$waiting = IniRead($projfle, $name, "wait", "0")
			If $waiting > 0 Then
				$subtot = $bytes
			Else
				$subtot = $subtot + $bytes
			EndIf
			IniWrite($projfle, $name, "subtotal", $subtot)
			$sum = $sum + $bytes
			IniWrite($projfle, "Total Size", "sum", $sum)
		EndIf
	Next
	$subtot = IniRead($projfle, $job, "subtotal", "")
	$waiting = IniRead($projfle, $job, "wait", "0")
	If $total = "sum" Then
		$bytes = $sum
	ElseIf $total = "sub" Then
		$bytes = $subtot
	EndIf
	SourceGetBytes()
	If $total = "sum" Then
		$sum = $bytes
		GUICtrlSetData($Label_sum, $sum)
	ElseIf $total = "sub" Then
		$subtot = $bytes
		GUICtrlSetData($Label_sum, $subtot)
	EndIf
EndFunc ;=> GetTotalSize

Func LoadProject()
	;$addconc = 4
	;$addsolo = 4
	$combfle = ""
	;$how = ""
	$source = ""
	;
	$jobs = IniRead($projfle, "Jobs", "names", "")
	If $jobs = "" Then $jobs = "||"
	$job = StringSplit($jobs, "|")
	If $job[0] > 3 Then
		$job = $job[3]
	Else
		$job = ""
	EndIf
	GUICtrlSetData($Combo_job, $jobs, $job)
	;
	$total = "sum"
	$nums = "|"
	$tot = IniRead($projfle, "Jobs", "total", 0)
	If $tot <> 0 Then
		For $n = 1 To $tot
			$nums = $nums & "|" & $n
		Next
		$source = IniRead($projfle, $job, "source", "")
		If $source <> "" Then
			;$source = StringReplace($source, "<", "[")
			;$source = StringReplace($source, ">", "]")
			GUICtrlSetData($Input_srce, $source)
			If Not FileExists($source) Then MsgBox(262192, "Source Error", "Path does not exist!", 0, $TCTimer)
		EndIf
		$dest = IniRead($projfle, $job, "destination", "")
		If $dest <> "" Then
			;$dest = StringReplace($dest, "<", "[")
			;$dest = StringReplace($dest, ">", "]")
			GUICtrlSetData($Input_dest, $dest)
			If Not FileExists($dest) Then
				GUICtrlSetState($Button_set, $GUI_DISABLE)
				MsgBox(262192, "Destination Error", "Path does not exist!", 0, $TCTimer)
				GUICtrlSetState($Button_min, $GUI_DISABLE)
			EndIf
		Else
			; Don't get Last destination, as it is not set for any existing jobs.
		EndIf
		$bytes = IniRead($projfle, $job, "size", "")
		SourceGetBytes()
		GUICtrlSetData($Label_size, $bytes)
		GetTotalSize()
		$waiting = IniRead($projfle, $job, "wait", "0")
		GUICtrlSetData($Combo_wait, $waiting)
		If $waiting > 0 Then
			MsgBox(262192, "Wait Alert", "First job has a waiting period before it" _
				& @LF & "starts. Please set to '0' if not wanted.", 0, $TCTimer)
		EndIf
	Else
		$dest = IniRead($inifle, "Destination Path", "last", "")
		If $dest <> "" Then
			;$dest = StringReplace($dest, "<", "[")
			;$dest = StringReplace($dest, ">", "]")
			If Not FileExists($dest) Then
				; NOTE - Consider doing a drive letter check, and different response if not exist,
				; due to it having been an obvious removable HDD, that could be connected again.
				$ans = MsgBox(262449, "Wipe Query", _
					"The Last recorded Destination path, does not currently exist." & @LF & @LF & _
					$dest & @LF & @LF & _
					"Do you want to delete (remove) it from the record?", 0, $TCTimer)
				If $ans = 1 Then
					IniWrite($inifle, "Destination Path", "last", "")
				EndIf
				$dest = ""
			Else
				GUICtrlSetData($Input_dest, $dest)
			EndIf
		EndIf
		If $dest = "" Then
			GUICtrlSetState($Button_set, $GUI_DISABLE)
			GUICtrlSetState($Button_min, $GUI_DISABLE)
		EndIf
	EndIf
	;
	If $tot > 0 Then
		GUICtrlSetData($Combo_ord, $nums, "1")
		$pths = 0
		If $job <> "" Then
			If StringLeft($job, 14) = "Combine List _" Then
				If StringIsDigit(StringReplace($job, "Combine List _", "")) = 1 Then
					$combfle = IniRead($projfle, $job, "source", "")
					If FileExists($combfle) Then
						If StringRight($combfle, 4) = ".txt" Then
							If StringInStr($combfle, "Combine List _") > 0 Then
								GetCombineFileTruePathsCount()
							EndIf
						EndIf
					EndIf
				EndIf
			EndIf
		EndIf
		If $combfle = "" Then
			GUICtrlSetData($Group_pths, "Job Paths  (" & $tot & ")")
		Else
			GUICtrlSetData($Group_pths, "Job Paths  (" & $tot & ") (" & $pths & ")")
		EndIf
	Else
		GUICtrlSetData($Combo_ord, $nums, $tot)
	EndIf
EndFunc ;=> LoadProject

Func RemoveAfterCancel()
	Local $r, $rems, $remtot
	If $remlist = "" Then
		$ans = MsgBox(262433, "Removal Query (1)", _
			"You have elected to cancel before ALL jobs have" & @LF & _
			"completed, perhaps even before the current job" & @LF & _
			"(first) has ended (i.e. you closed TeraCopy)." & @LF & @LF & _
			$job & @LF & @LF & _
			"Do you want to remove that Job from the List?" & @LF & @LF & _
			"OK = Remove that current (first) job." & @LF & _
			"CANCEL = Don't remove current job." & @LF & @LF & _
			"WARNING - Current job might be paused and in" & @LF & _
			"a 'wait' period, before it starts.", 0, $TCTimer)
		If $ans = 1 Then
			$remlist = $job
			RemoveFinishedJobs()
		EndIf
	Else
		$rems = StringSplit($remlist, "|", 1)
		$remtot = $rems[0]
		$ans = MsgBox(262691, "Removal Query (" & $remtot & ")", _
			"You have elected to cancel before ALL jobs have" & @LF & _
			"completed, perhaps even before the current job" & @LF & _
			"(last) had finished (i.e. you closed TeraCopy)." & @LF & @LF & _
			$job & @LF & @LF & _
			"Do you want to remove any from the Job List?" & @LF & @LF & _
			"YES = Remove that current job and all prior." & @LF & _
			"NO = Just remove prior job(s)." & @LF & _
			"CANCEL = Don't remove any jobs." & @LF & @LF & _
			"WARNING - Current job might be paused and in" & @LF & _
			"a 'wait' period, before it starts.", 0, $TCTimer)
		If $ans = 2 Then
			$remlist = ""
		Else
			If $ans = 6 Then
				RemoveFinishedJobs()
			EndIf
			For $r = 1 To $remtot
				$job = $rems[$r]
				If $job <> "" Then
					RemoveFinishedJobs()
				EndIf
			Next
		EndIf
	EndIf
	If $ans <> 2 Then
		$job = ""
		$source = ""
		$dest = ""
		$bytes = ""
		$sum = ""
		$copy = "copy"
		If $tot > 0 Then
			$job = IniRead($projfle, "Jobs", "1", "")
			If $job <> "" Then
				GUICtrlSetData($Combo_job, $jobs, $job)
				ShowDetailsForJob()
				If $waiting > 0 Then
					MsgBox(262192, "Wait Alert", "New first job has a waiting period before it" _
						& @LF & "starts. Please set it to '0' if not wanted.", 0, $TCTimer)
				EndIf
			EndIf
		EndIf
		If $job = "" Then
			GUICtrlSetData($Combo_job, $jobs, $job)
			GUICtrlSetData($Input_srce, $source)
			GUICtrlSetData($Input_dest, $dest)
			GUICtrlSetData($Label_size, $bytes)
			GUICtrlSetData($Label_sum, $sum)
			GUICtrlSetData($Combo_copy, $copy)
		EndIf
	EndIf
EndFunc ;=> RemoveAfterCancel

Func RemoveFinishedJobs()
	If StringInStr($jobs, "|" & $job & "|") > 0 Then
		SplashTextOn("", "Recalculating!", 200, 80, -1, -1, 33)
		$jobs = StringReplace($jobs, "|" & $job & "|", "|")
		IniWrite($projfle, "Jobs", "names", $jobs)
		GUICtrlSetData($Combo_job, "", "")
		;
		$n = IniRead($projfle, $job, "order", "")
		$tot = IniRead($projfle, "Jobs", "total", $tot)
		$nums = "|"
		For $t = 1 To $tot
			If $t < $tot Then
				$nums = $nums & "|" & $t
				If $t >= $n Then
					$tmp = IniRead($projfle, "Jobs", $t + 1, "")
					IniWrite($projfle, "Jobs", $t, $tmp)
					IniWrite($projfle, $tmp, "order", $t)
				EndIf
			Else
				IniDelete($projfle, "Jobs", $tot)
			EndIf
		Next
		$tot = $tot - 1
		IniWrite($projfle, "Jobs", "total", $tot)
		If $tot > 0 Then
			GUICtrlSetData($Group_pths, "Job Paths  (" & $tot & ")")
		Else
			GUICtrlSetData($Group_pths, "Job Paths")
		EndIf
		If StringLeft($job, 14) = "Combine List _" Then
			If StringIsDigit(StringReplace($job, "Combine List _", "")) = 1 Then
				$combfle = IniRead($projfle, $job, "source", "")
				If FileExists($combfle) Then
					If StringRight($combfle, 4) = ".txt" Then
						If StringInStr($combfle, "Combine List _") > 0 Then
							FileDelete($combfle)
						EndIf
					EndIf
				EndIf
			EndIf
		EndIf
		IniDelete($projfle, $job)
		GUICtrlSetData($Combo_ord, "", "")
		GUICtrlSetData($Combo_ord, $nums, "")
		;
		;GUICtrlSetData($Label_size, "")
		;GetTotalSize()
		SplashOff()
	EndIf
EndFunc ;=> RemoveFinishedJobs

Func RemoveQuery()
	$ans = MsgBox(262193, "Remove ALL Query", _
		"Are you sure you want all of the currently listed" & @LF & _
		"jobs and their settings, to be deleted/removed?", 0, $TCTimer)
	If $ans = 1 Then
		$jobs = StringSplit($jobs, "|")
		$tot = $jobs[0] - 1
		For $t = 3 To $tot
			$job = $jobs[$t]
			If StringLeft($job, 14) = "Combine List _" Then
				If StringIsDigit(StringReplace($job, "Combine List _", "")) = 1 Then
					$combfle = IniRead($projfle, $job, "source", "")
					If FileExists($combfle) Then
						If StringRight($combfle, 4) = ".txt" Then
							If StringInStr($combfle, "Combine List _") > 0 Then
								FileDelete($combfle)
							EndIf
						EndIf
					EndIf
				EndIf
			EndIf
			IniDelete($projfle, $job)
		Next
		If $updated = 1 Then
			If $projfle = $inifle Then
				MsgBox(262192, "Removal Error", "Probable program update error, as project file and 'Settings.ini' file are the same!", 0, $TCTimer)
				Return
			Else
				FileDelete($projfle)
				$projfle = ""
				IniWrite($inifle, "Last Project", "file", $projfle)
				$jobs = "||"
				$nums = "|"
				$tot = 0
			EndIf
		Else
			$jobs = "||"
			IniWrite($projfle, "Jobs", "names", $jobs)
			$nums = "|"
			$tot = 0
			IniWrite($projfle, "Jobs", "total", $tot)
		EndIf
		GUICtrlSetData($Group_pths, "Job Paths")
		GUICtrlSetData($Combo_job, "", "")
		GUICtrlSetData($Combo_job, $jobs, "")
		GUICtrlSetData($Combo_ord, "", "")
		GUICtrlSetData($Combo_ord, $nums, "")
		GUICtrlSetData($Combo_copy, "", "")
		GUICtrlSetData($Combo_copy, $proc, "copy")
		GUICtrlSetData($Label_size, "")
		GUICtrlSetData($Label_sum, "")
	EndIf
EndFunc ;=> RemoveQuery

Func SaveJobSettings()
	;$dest = StringReplace($dest, "<", "[")
	;$dest = StringReplace($dest, ">", "]")
	If Not FileExists($dest) Then
		$ans = MsgBox(262193, "Destination Query", _
			"You are using a destination path that does not yet exist." & @LF & @LF & _
			"Do you want this folder path to be created now?" & @LF & @LF & _
			"NOTE - If it isn't created now, then the path will not be" & @LF & _
			"saved and the job will be skipped during processing." & @LF & @LF & _
			"You got this prompt, probably because you've manually" & @LF & _
			"typed in a destination path that has errors or does not" & @LF & _
			"yet exist or the SOURCE button was used for same.", 0, $TCTimer)
		If $ans = 1 Then
			SplashTextOn("", "Please Wait", 200, 80, -1, -1, 33)
			DirCreate($dest)
			Sleep(2000)
			SplashOff()
		EndIf
	EndIf
	If FileExists($dest) Then
		If $projfle = "" Then GetSetProjectFile(1)
		If IniRead($projfle, $job, "destination", "") = "" Then
			$ans = 1
		Else
			$ans = MsgBox(262193, "Update Query", _
				"A destination path already exists for this job." & @LF & @LF & _
				"Do you want to update/overwrite?", 0, $TCTimer)
		EndIf
		If $ans = 1 Then
			;$dest = StringReplace($dest, "[", "<")
			;$dest = StringReplace($dest, "]", ">")
			IniWrite($projfle, $job, "destination", $dest)
			$copy = GUICtrlRead($Combo_copy)
			If $tot = 1 And $ask = 1 Then
				$ans = MsgBox(262177, "Process Query", _
					"This is the first job to be set, and so to avoid" & @LF & _
					"mistakes that will need correcting, we are just" & @LF & _
					"confirming, in accordance with settings, that" & @LF & _
					"the process you wish to use is - XXXX?" & @LF & @LF & _
					"OK = Copy." & @LF & _
					"CANCEL = Move." & @LF & @LF & _
					"NOTE - What is set becomes the default for" & @LF & _
					"later jobs this session, unless changed. This" & @LF & _
					"is where mistakes may occur, if forgotten.", 0, $TCTimer)
				If $ans = 1 Then
					$ans = "copy"
				ElseIf $ans = 2 Then
					$ans = "move"
				EndIf
				If $ans <> $copy Then
					$copy = $ans
					GUICtrlSetData($Combo_copy, $copy)
				EndIf
			EndIf
			IniWrite($projfle, $job, "process", $copy)
			GUICtrlSetState($Button_set, $GUI_ENABLE)
			GUICtrlSetState($Button_min, $GUI_ENABLE)
		EndIf
	Else
		MsgBox(262192, "Path Error", "Destination path/location does not exist.", 0, $TCTimer)
	EndIf
EndFunc ;=> SaveJobSettings

Func SetControlsState($state)
	If $state = $GUI_HIDE Then
		GUICtrlSetState($Label_add, $GUI_SHOW)
		GUICtrlSetState($Combo_how, $GUI_SHOW)
	Else
		GUICtrlSetState($Label_add, $GUI_HIDE)
		GUICtrlSetState($Combo_how, $GUI_HIDE)
	EndIf
	;
	GUICtrlSetState($Checkbox_up, $state)
	GUICtrlSetState($Button_set, $state)
	GUICtrlSetState($Button_sfle, $state)
	GUICtrlSetState($Button_sfld, $state)
	;
	GUICtrlSetState($Group_dest, $state)
	GUICtrlSetState($Button_srce, $state)
	GUICtrlSetState($Button_last, $state)
	GUICtrlSetState($Button_change, $state)
	GUICtrlSetState($Button_process, $state)
	GUICtrlSetState($Input_dest, $state)
	GUICtrlSetState($Combo_copy, $state)
	GUICtrlSetState($Checkbox_ask, $state)
	GUICtrlSetState($Button_sav, $state)
	GUICtrlSetState($Button_dest, $state)
	;
	GUICtrlSetState($Group_job, $state)
	GUICtrlSetState($Combo_job, $state)
	GUICtrlSetState($Button_del, $state)
	;
	GUICtrlSetState($Group_ord, $state)
	GUICtrlSetState($Combo_ord, $state)
	GUICtrlSetState($Input_ord, $state)
	GUICtrlSetState($Updown_ord, $state)
	If $state = $GUI_SHOW Then GUICtrlSetState($Updown_ord, $GUI_ONTOP)
	;
	GUICtrlSetState($Group_delay, $state)
	GUICtrlSetState($Button_adv, $state)
	GUICtrlSetState($Input_delay, $state)
	GUICtrlSetState($Updown_delay, $state)
	GUICtrlSetState($Label_delay, $state)
	;
	GUICtrlSetState($Button_start, $state)
	;
	GUICtrlSetState($Checkbox_shut, $state)
	;
	GUICtrlSetState($Group_fav, $state)
	GUICtrlSetState($Combo_fav, $state)
	GUICtrlSetState($Button_add, $state)
	;
	GUICtrlSetState($Checkbox_use, $state)
	;
	GUICtrlSetState($Checkbox_thumb, $state)
	;
	GUICtrlSetState($Button_i, $state)
	GUICtrlSetState($Button_x, $state)
EndFunc ;=> SetControlsState

Func SetTheJobName()
	$source = GUICtrlRead($Input_srce)
	If $source <> "" Then
		If FileExists($source) Then
			If $projfle = "" Then GetSetProjectFile(1)
			SourceGetSize(0)
			SplashTextOn("", "Calculating!", 200, 80, -1, -1, 33)
			If $up = 1 Then
				$job = GUICtrlRead($Combo_job)
				If $job <> "" Then
					If IniRead($projfle, $job, "source", "") <> "" Then
						$ans = MsgBox(262193, "Job Name Query", _
							"A job already exists with the following name -" & @LF & @LF & _
							$job & @LF & @LF & _
							"Do you want to overwrite/update that job?" & @LF & @LF & _
							"CANCEL = Abort updating.", 0, $TCTimer)
						If $ans = 1 Then
							;$source = StringReplace($source, "[", "<")
							;$source = StringReplace($source, "]", ">")
							IniWrite($projfle, $job, "source", $source)
							IniWrite($projfle, $job, "size", $bytes)
							$dest = GUICtrlRead($Input_dest)
							If $dest <> "" Then
								UpdateDestinationValues()
							EndIf
						EndIf
					Else
						MsgBox(262192, "Update Error", "Job name doesn't exist.", 0, $TCTimer)
					EndIf
				Else
					MsgBox(262192, "Update Error", "A job name has not been selected.", 0, $TCTimer)
				EndIf
			Else
				$job = StringSplit($source, "\")
				$job = $job[$job[0]]
				;$job = StringSplit($job, ".")
				;$job = $job[1]
				If $typ = "file" Then
					$pos = StringInStr($job, ".", 0, -1)
					If $pos > 0 Then $job = StringLeft($job, $pos - 1)
				EndIf
				;$job = StringReplace($job, ".", "-")
				$job = StringReplace($job, "[", "<")
				$job = StringReplace($job, "]", ">")
				$n = 1
				While 1
					If IniRead($projfle, $job & "_" & $n, "source", "") = "" Then
						$job = $job & "_" & $n
						ExitLoop
					EndIf
					$n = $n + 1
				WEnd
				If $skip = "" Then
					$job = InputBox("Job Name", "Specify the Job Name.", $job, "", 200, 120, -1, -1, 0, $TCTimer)
					If @error Then $job = ""
				EndIf
				If $job <> "" Then
					$update = ""
					If IniRead($projfle, $job, "source", "") <> "" Then
						$ans = MsgBox(262193, "Job Name Query", _
							"A job already exists with the following name -" & @LF & @LF & _
							$job & @LF & @LF & _
							"Do you want to overwrite/update that job?" & @LF & @LF & _
							"CANCEL = Abort updating." & @LF & @LF & _
							"Use CAUTION when updating.", 0, $TCTimer)
						If $ans = 1 Then $update = 1
					Else
						$ans = 1
					EndIf
					If $ans = 1 Then
						IniWrite($projfle, $job, "source", $source)
						IniWrite($projfle, $job, "size", $bytes)
						GUICtrlSetData($Combo_ord, "", "")
						If $update = "" Then
							$jobs = $jobs & $job & "|"
							IniWrite($projfle, "Jobs", "names", $jobs)
							$tot = IniRead($projfle, "Jobs", "total", $tot)
							$tot = $tot + 1
							IniWrite($projfle, $job, "order", $tot)
							IniWrite($projfle, "Jobs", "total", $tot)
							IniWrite($projfle, "Jobs", $tot, $job)
							$nums = $nums & "|" & $tot
							GUICtrlSetData($Combo_ord, $nums, $tot)
							GUICtrlSetData($Group_pths, "Job Paths  (" & $tot & ")")
						Else
							$n = IniRead($projfle, $job, "order", "")
							GUICtrlSetData($Combo_ord, $nums, $n)
						EndIf
						GUICtrlSetData($Combo_job, "", "")
						GUICtrlSetData($Combo_job, $jobs, $job)
						GUICtrlSetState($Button_set, $GUI_DISABLE)
						GUICtrlSetState($Button_min, $GUI_DISABLE)
						$dest = GUICtrlRead($Input_dest)
						If $dest <> "" Then
							UpdateDestinationValues()
						EndIf
						;MsgBox(262192, "$nums $tot", $nums & ":" & $tot, 0)
					EndIf
				Else
					$job = ""
				EndIf
			EndIf
			SourceGetBytes()
			GUICtrlSetData($Label_size, $bytes)
			GetTotalSize()
			SplashOff()
		Else
			MsgBox(262192, "Path Error", "Source path/location does not exist.", 0, $TCTimer)
		EndIf
	Else
		MsgBox(262192, "Path Error", "Source path/location has not been set.", 0, $TCTimer)
	EndIf
EndFunc ;=> SetTheJobName

Func ShowDetailsForJob()
	$combfle = ""
	$source = IniRead($projfle, $job, "source", "")
	GUICtrlSetData($Input_srce, $source)
	$waiting = IniRead($projfle, $job, "wait", "0")
	GUICtrlSetData($Combo_wait, $waiting)
	$bytes = IniRead($projfle, $job, "size", "")
	SourceGetBytes()
	GUICtrlSetData($Label_size, $bytes)
	GetTotalSize()
	$dest = IniRead($projfle, $job, "destination", "")
	GUICtrlSetData($Input_dest, $dest)
	If $dest = "" Then
		GUICtrlSetState($Button_set, $GUI_DISABLE)
		GUICtrlSetState($Button_min, $GUI_DISABLE)
	Else
		GUICtrlSetState($Button_set, $GUI_ENABLE)
		GUICtrlSetState($Button_min, $GUI_ENABLE)
	EndIf
	$copy = IniRead($projfle, $job, "process", "")
	GUICtrlSetData($Combo_copy, $copy)
	$n = IniRead($projfle, $job, "order", "")
	GUICtrlSetData($Combo_ord, "", "")
	GUICtrlSetData($Combo_ord, $nums, $n)
	;
	If StringLeft($job, 14) = "Combine List _" Then
		If StringIsDigit(StringReplace($job, "Combine List _", "")) = 1 Then
			$combfle = IniRead($projfle, $job, "source", "")
			If FileExists($combfle) Then
				If StringRight($combfle, 4) = ".txt" Then
					If StringInStr($combfle, "Combine List _") > 0 Then
						GetCombineFileTruePathsCount()
					EndIf
				EndIf
			EndIf
		EndIf
	EndIf
EndFunc ;=> ShowDetailsForJob

Func SourceGetBytes()
	If $bytes > 0 Then
		If $bytes > 1024 Then
			If $bytes > 1048576 Then
				$bytes = $bytes / 1048576
				If $bytes > 1024 Then
					$bytes = $bytes / 1024
					$bytes = Round($bytes, 2) & " Gb's"
				Else
					$bytes = Round($bytes, 2) & " Mb's"
				EndIf
			Else
				$bytes = $bytes / 1024
				$bytes = Round($bytes, 2) & " Kb's"
			EndIf
		Else
			$bytes = $bytes & " bytes"
		EndIf
	Else
		$bytes = "0 bytes"
	EndIf
EndFunc ;=> SourceGetBytes

Func SourceGetSize($ret)
	If $ret = 0 Then SplashTextOn("", "Getting Size", 200, 80, -1, -1, 33)
	$typ = FileGetAttrib($source)
	If StringInStr($typ, "D") > 0 Then
		$typ = "folder"
		$bytes = DirGetSize($source)
	Else
		$typ = "file"
		$bytes = FileGetSize($source)
	EndIf
	If $ret = 0 Then
		$mbs = $bytes / 1048576
		If $mbs > 1024 Then
			$size = $mbs / 1024
			$size = Round($size, 2) & " Gb's"
		Else
			$size = Round($mbs, 2) & " Mb's"
		EndIf
		SplashOff()
	EndIf
EndFunc ;=> SourceGetSize

Func UpdateDestinationValues()
	;$dest = StringReplace($dest, "[", "<")
	;$dest = StringReplace($dest, "]", ">")
	If $dest <> IniRead($projfle, $job, "destination", "") Then
		If $skip = 1 Then
			SaveJobSettings()
		Else
			$ans = MsgBox(262193, "Destination Query", "Do you want to use the currently listed destination path?", 0, $TCTimer)
			If $ans = 1 Then
				SaveJobSettings()
			Else
				$dest = IniRead($projfle, $job, "destination", "")
				GUICtrlSetData($Input_dest, $dest)
			EndIf
		EndIf
	Else
		$copy = GUICtrlRead($Combo_copy)
		If $copy <> IniRead($projfle, $job, "process", "") Then
			$ans = MsgBox(262193, "Process Query", "Do you want to update the different copy/move value?", 0, $TCTimer)
			If $ans = 1 Then
				IniWrite($projfle, $job, "process", $copy)
			Else
				$copy = IniRead($projfle, $job, "process", "")
				If $copy = "" Then $copy = GUICtrlRead($Combo_copy)
				GUICtrlSetData($Combo_copy, $copy)
			EndIf
		EndIf
	EndIf
EndFunc ;=> UpdateDestinationValues

Func ViewCombineList()
	GUICtrlSetData($Combo_how, "||Add To List|New List|View List", $how)
	$combfle = $source
	;MsgBox(262192, "$combfle $job", $combfle & @LF & $job & ".txt", 0, $TCTimer)
	If StringRight($combfle, StringLen($job) + 4) = $job & ".txt" Then
		If FileExists($combfle) Then
			Run(@WindowsDir & "\Notepad.exe " & $combfle)
			;
			Sleep(1500)
			$ans = MsgBox(262436, "Update Query", _
				"Notepad should appear and show" & @LF & _
				"the combine file content (paths)." & @LF & _
				"Please Wait until you have closed" & @LF & _
				"it before responding." & @LF & @LF & _
				"Did you make any changes to the" & @LF & _
				"selected combine file content?", 0, $TCTimer)
			If $ans = 6 Then
				SplashTextOn("", "Recalculating!", 200, 80, -1, -1, 33)
				$res = _FileReadToArray($combfle, $sizes)
				If $res = 1 Then
					$combsze = 0
					For $a = 1 To $sizes[0]
						$source = $sizes[$a]
						If FileExists($source) Then
							SourceGetSize(1)
							$combsze = $combsze + $bytes
						EndIf
					Next
					$source = $combfle
					If $combsze <> IniRead($projfle, $job, "size", "") Then
						IniWrite($projfle, $job, "size", $combsze)
						$bytes = $combsze
						SourceGetBytes()
						GUICtrlSetData($Label_size, $bytes)
						GetTotalSize()
					EndIf
				EndIf
				SplashOff()
			EndIf
		Else
			MsgBox(262192, "Path Error", "File not found!", 0, $TCTimer)
		EndIf
	Else
		$combfle = ""
		;$job = ""
	EndIf
EndFunc ;=> ViewCombineList


; Provided by Lazycat, June 23, 2006 in AutoIt Example Scripts (Drop multiple files on any control)
Func WM_DROPFILES_FUNC($hWnd, $msgID, $wParam, $lParam)
    Local $nSize, $pFileName
    Local $nAmt = DllCall("shell32.dll", "int", "DragQueryFile", "hwnd", $wParam, "int", 0xFFFFFFFF, "ptr", 0, "int", 255)
    For $i = 0 To $nAmt[0] - 1
        $nSize = DllCall("shell32.dll", "int", "DragQueryFile", "hwnd", $wParam, "int", $i, "ptr", 0, "int", 0)
        $nSize = $nSize[0] + 1
        $pFileName = DllStructCreate("char[" & $nSize & "]")
        DllCall("shell32.dll", "int", "DragQueryFile", "hwnd", $wParam, "int", $i, "ptr", DllStructGetPtr($pFileName), "int", $nSize)
        ReDim $gaDropFiles[$i+1]
        $gaDropFiles[$i] = DllStructGetData($pFileName, 1)
        $pFileName = 0
    Next
EndFunc ;=> WM_DROPFILES_FUNC
